*     File ephcolg.f : Mon Nov  3 15:04:57 2008
*
*     Generated by GRACE (Fortran source code generator)
*         Ver.2.2.0(107) 2006/01/16
*
*     (c)Copyright 1990-2006 Minami-Tateya Group (Japan)
*     F.Yuasa et al, Prog.Theor.Phys.Suppl.138(2000)18
*-----------------------------------------------------------------------
*
C
C Subroutine ephCOL(XX,E1,E2,IHEL1,IHEL2,W)
C
C (Purpose)
C    Generate weight factor for Gamma Gamma Luminosity
C
C   this is only for 500 GeV data
C   IFL is not used now          Aug.1 00  t.takahash
C                         
C (Inputs)
C       XX(1)   : integrate variable for energy of photonR (0,1)
C       XX(2)   : integrate variable for energy of photonL (0,1)
C       XX(3)   : integrate variable for helicity1         [0,1]
C       
C (Outputs) 
C       E1   : energy of right-moving photon   (GeV) 
C       E2   : energy of left -moving photon   (GeV)
C       IHEL1: helicity of right-moving photon
C       IHEL2: helicity of left -moving photon
C       W    : weight factor for gamma gamma luminosity
C
C (Relation)
C       NONE
C
C (Update Record)
C    26/05/95   Tomomi Ohgaki       Original version (ggcol.f).
C    15/06/95   Tohru Takahashi     modified from ggcol.f.           
C    06/07/95   Tomomi Ohgaki       modified.
C    22/12/98   Katsumasa Ikematsu  Integrate variables were replaced
C                                   sqrt(s) & rapidity with energy of
C                                   photonR & L because of boost problem.
C
      SUBROUTINE EPHCOL(IFL,XX,E1,E2,IHEL1,IHEL2,W)

      IMPLICIT NONE

      INTEGER IHEL1,IHEL2,ID,IFL      
      REAL*8  E1,E2,W
      REAL*8  XX(3)
      LOGICAL EX

      INTEGER IFIRST,I,J,NBIN1,NBIN2,NW1,NW2,NDATA(2),NH
      REAL*8  MOD
      REAL*8  PL(100,100)
      REAL*8  RLTOT,X,EB,RW1,RW2,RHEL,XNHEL,RL1,RL2,RL
      REAL*8  PL1TOT,PL2TOT,PL3TOT,PL4TOT
      REAL*8  PL1(100,100),PL2(100,100),PL3(100,100),PL4(100,100)
      CHARACTER*80 FNAME(5)
#if 0
      DATA FNAME / 'data/kain/bb500.dat',
#else
      DATA FNAME / 'data/kain/gg420.dat',
*     DATA FNAME / 'data/kain/gg390.dat',
#endif
     &            'data/kain/gg500.dat',
     &            'data/kain/gg500.90.dat',
     &            'data/kain/gg500+.dat',
     &            'data/kain/gg1000.dat'/
C
      common /collid3/ RLTOT
C ---< Luminosity distribution from CAIN >-----------------------------
C
C Include luminosity distribution from CAIN
C
C  I        : W1-bin for energy of right-moving photon
C  J        : W2-bin for energy of left -moving photon
C
C  Polarized luminosity distribution ( Unit cm^{-2} s^{-1} bin^(-1) ) 
C
C ( helicity of left-moving photon, helicity of right-moving photon )
C          
C  PL1(*,*) : (+,+) helicity combination ( Unit cm^{-2} s^{-1} bin^{-1} )
C  PL2(*,*) : (+,-)                     
C  PL3(*,*) : (-,+)
C  PL4(*,*) : (-,-)
C
C ---< Initial Data >--------------------------------------------------
C
C  IFIRST  : flag for PL(*,*)     
C  X       : Compton kinematics parameter 
C                    X=4E_{e}w_{0}/m_{e}^{2}cos^{2}(\alpha/2)
C  EB      : initial energy of electron beam (GeV) 
C  NDATA   : data for helicity of final photon
C  NBIN1   : number of W1-bin for gamma gamma luminosity
C  NBIN2   : number of W2-bin for gamma gamma luminosity
C
      DATA IFIRST /1/
      DATA X /4.75d0/
      DATA EB /250.d0/
      DATA NDATA /1,-1/
      DATA NBIN1, NBIN2 /100,100/

      W = 0.0D0
      E1 = 0.0D0
      E2 = 0.0D0
C
C ---< Total Luminosity >----------------------------------------------
C
C  RLTOT   : Total luminosity ( Unit cm^{-2}s^{-1} )
C
      IF (IFIRST.EQ.1) THEN
         ID = 1
c         IF(IFL .eq. -1) ID = 1
c         IF(IFL .eq. -5) ID = 2
c         IF(IFL .eq. -59) ID = 3
c         IF(IFL .eq.  5) ID = 4
c         IF(IFL .eq. -10) ID = 5
c         IF(ID .eq. -999) THEN
c          WRITE(6,*) ' **** EPHCOL >> Illeagel frag IFL = ', IFL
c          STOP
c         END IF
         INQUIRE(file= FNAME(ID),exist=ex)
         IF(.NOT. EX) THEN
          WRITE(6,*) ' **** EPHCOL >> file ',FNAME(ID),' not exist'
          STOP
         END IF
         WRITE(6,*) FNAME(ID)
         DO 11 I=1,NBIN1
            DO 21 J=1,NBIN2
               PL1(I,J) = 0.d0
               PL2(I,J) = 0.d0
               PL3(I,J) = 0.d0
               PL4(I,J) = 0.d0
               PL(I,J) = 0.d0
 21         CONTINUE
 11      CONTINUE
         OPEN(55,FILE = FNAME(ID),FORM = 'FORMATTED',STATUS='OLD')
               READ(55,*) EB,X

c         write(*,*) 'EB =', EB
c         write(*,*) 'X =', X
c         write(*,*) 'NBIN1 =', NBIN1
c         write(*,*) 'NBIN2 =', NBIN2
            DO 110 J = 1, NBIN2
               READ(55,*) (PL1(I,J),I=1,NBIN1)
 110        CONTINUE
c         write(*,*) 'PL1(1,1) =', PL1(1,1)
c         write(*,*) 'PL1(100,100) =', PL1(100,100)
            DO 120 J = 1, NBIN2
               READ(55,*) (PL2(I,J),I=1,NBIN1)
 120        CONTINUE
c         write(*,*) 'PL2(1,1) =', PL2(1,1)
c         write(*,*) 'PL2(100,100) =', PL2(100,100)
            DO 130 J = 1, NBIN2
               READ(55,*) (PL3(I,J),I=1,NBIN1)
 130        CONTINUE
c         write(*,*) 'PL3(1,1) =', PL3(1,1)
c         write(*,*) 'PL3(100,100) =', PL3(100,100)
            DO 140 J = 1, NBIN2
               READ(55,*) (PL4(I,J),I=1,NBIN1)
 140        CONTINUE
c         write(*,*) 'PL4(1,1) =', PL4(1,1)
c         write(*,*) 'PL4(100,100) =', PL4(100,100)
            CLOSE(55)
c         write(*,*) 'check3'

         RLTOT = 0.d0
         PL1TOT = 0.d0
         PL2TOT = 0.d0
         PL3TOT = 0.d0
         PL4TOT = 0.d0
         DO 10 I=1,NBIN1
            DO 20 J=1,NBIN2
               PL(I,J) = PL1(I,J) + PL2(I,J) + PL3(I,J) + PL4(I,J)
               RLTOT = RLTOT + PL(I,J)
               PL1TOT = PL1TOT + PL1(I,J)
               PL2TOT = PL2TOT + PL2(I,J)
               PL3TOT = PL3TOT + PL3(I,J)
               PL4TOT = PL4TOT + PL4(I,J)
 20         CONTINUE
 10      CONTINUE
c         write(*,*) 'PL(1,1) =', PL(1,1)
c         write(*,*) 'PL(100,100) =', PL(100,100)

         IFIRST = 0
         PRINT *,' PL1TOT ',PL1TOT,' ( cm^{-2}s^{-1} )'
         PRINT *,' PL2TOT ',PL2TOT,' ( cm^{-2}s^{-1} )'
         PRINT *,' PL3TOT ',PL3TOT,' ( cm^{-2}s^{-1} )'
         PRINT *,' PL4TOT ',PL4TOT,' ( cm^{-2}s^{-1} )'
         PRINT *,' Total luminosity ',RLTOT,' ( cm^{-2}s^{-1} )'
      ENDIF
C
C ---< Energy of Gamma Gamma Collision >-------------------------------
C
#if 0
      E1 = EB * XX(1)
      E2 = EB * XX(2)
#else
      E1 =XX(1)
      E2 =XX(2)
#endif
C
C ---< Helicity Combination of Gamma Gamma Collision >-----------------
C
C  RHEL, XNHEL, NH : decide the helicity combination
C
      RHEL = 4
      XNHEL = RHEL*XX(3)

      NH = MOD(XNHEL/2.d0,2.d0) + 1
      IHEL1 = NDATA(NH)

      NH = MOD(XNHEL,2.d0) + 1
      IHEL2 = NDATA(NH)
CDBG
      IF ( (IHEL1.EQ.50) .OR. (IHEL2.EQ.50) ) THEN
CDBG         PRINT *,''
CDBG         PRINT *,' **** EPHCOL >> Wrong helicity !!'
CDBG         PRINT *,''
         STOP
      END IF
CGG
C
C ---< Interpolation of polarized luminosity >-----------------
C
C  RW1   : absolute value in W1-bin (real)
C  RW2   : absolute value in W2-bin (real)
C  NW1   : number of W1-bin (Integer)
C  NW2   : number of W2-bin (Integer)
C  RL    : polarized luminosity
C  RL1   : interpolation of W1-bin 
C  RL2   : interpolation of W2-bin
C   
      RW1 = NBIN1*XX(1)
      RW2 = NBIN2*XX(2)

      NW1 = RW1
      NW2 = RW2

      IF (NW1 .EQ. NBIN1) RETURN 
      IF (NW2 .EQ. NBIN2) RETURN 
      IF (NW1 .EQ. 0) RETURN 
      IF (NW2 .EQ. 0) RETURN 
C
C  helicity combination (-,-)
C
      IF (IHEL1 .EQ. -1 .AND. IHEL2 .EQ. -1) THEN

         RL1 = (PL4(NW1+1,NW2)-PL4(NW1,NW2))*(RW1-FLOAT(NW1)) 
     %         + PL4(NW1,NW2)
         RL2 = (PL4(NW1+1,NW2+1)-PL4(NW1,NW2+1))*(RW1-FLOAT(NW1)) 
     %         + PL4(NW1,NW2+1)
         RL = (RL2-RL1)*(RW2-FLOAT(NW2)) + RL1
C
C  helicity combination (+,-)
C
      ELSEIF (IHEL1 .EQ. 1 .AND. IHEL2 .EQ. -1) THEN
 
         RL1 = (PL2(NW1+1,NW2)-PL2(NW1,NW2))*(RW1-FLOAT(NW1)) 
     %         + PL2(NW1,NW2)
         RL2 = (PL2(NW1+1,NW2+1)-PL2(NW1,NW2+1))*(RW1-FLOAT(NW1)) 
     %         + PL2(NW1,NW2+1)
         RL = (RL2-RL1)*(RW2-FLOAT(NW2)) + RL1
C
C  helicity combination (-,+)
C
      ELSEIF (IHEL1 .EQ. -1 .AND. IHEL2 .EQ. 1) THEN
 
         RL1 = (PL3(NW1+1,NW2)-PL3(NW1,NW2))*(RW1-FLOAT(NW1)) 
     %         + PL3(NW1,NW2)
         RL2 = (PL3(NW1+1,NW2+1)-PL3(NW1,NW2+1))*(RW1-FLOAT(NW1)) 
     %         + PL3(NW1,NW2+1)
         RL = (RL2-RL1)*(RW2-FLOAT(NW2)) + RL1
C
C  helicity combination (+,+)
C
      ELSE

         RL1 = (PL1(NW1+1,NW2)-PL1(NW1,NW2))*(RW1-FLOAT(NW1)) 
     %         + PL1(NW1,NW2)
         RL2 = (PL1(NW1+1,NW2+1)-PL1(NW1,NW2+1))*(RW1-FLOAT(NW1)) 
     %         + PL1(NW1,NW2+1)
         RL = (RL2-RL1)*(RW2-FLOAT(NW2)) + RL1
  
      END IF
C
C ---< Weight for Gamma Gamma Luminosity >-----------------------------
C
c      W = RL*4.0D+4/RLTOT
#if 0
      W = RL
#else
      W = RL*4*NBIN1*NBIN2/RLTOT
#endif

      IF (W .LT. 0.0D0) W = 0.0D0
CDBG
CDBG      PRINT*,'W .RL  ',W,RL 
CDBG
      RETURN
      END

