{
   TCanvas *c1 = new TCanvas("c1", "c1",10,32,707,632);
   c1->Range(69.37999,-3.373641,1106.78,30.36277);
   c1->SetFillColor(0);
   c1->SetBorderMode(0);
   c1->SetBorderSize(2);
   c1->SetGridx();
   c1->SetGridy();
   c1->SetFrameBorderMode(0);
   c1->SetFrameBorderMode(0);

   ifstream fin("xsection.dat");

   double eaa[1000], ym[1000], y0[1000], yp[1000];
   double y1, y2, y3;

   int np = 0;
   while ((fin >> eaa[np] >> y1 >> y2 >> y3)) {
#if 1
   // Xsection plot
      ym[np] = y1; // delta kappa = -1
      y0[np] = y2; // delta kappa = 0 (SM)
      yp[np] = y3; // delta kappa = +1
      np++;
   };
   TGraph *grmp = new TGraph(np, eaa, ym);
   grmp->SetName("km1");
   grmp->SetTitle("");
   grmp->SetFillColor(1);
   grmp->SetMarkerColor(2);
   grmp->SetMarkerStyle(20);
   TGraph *gr0p = new TGraph(np, eaa, y0);
   gr0p->SetName("ksm");
   gr0p->SetTitle("");
   gr0p->SetFillColor(1);
   gr0p->SetMarkerColor(1);
   gr0p->SetMarkerStyle(20);
   TGraph *grpp = new TGraph(np, eaa, yp);
   grpp->SetName("kp1");
   grpp->SetTitle("");
   grpp->SetFillColor(1);
   grpp->SetMarkerColor(4);
   grpp->SetMarkerStyle(20);

   TH1F *frp = new TH1F("frp","",100,164,1076);
   frp->SetMinimum(0);
   frp->SetMaximum(0.7);
   frp->SetDirectory(0);
   frp->SetStats(0);
   frp->GetXaxis()->SetTitle("E_{#gamma#gamma} [GeV]");
   frp->GetXaxis()->SetRange(2,92);
   frp->GetXaxis()->SetLabelFont(42);
   frp->GetXaxis()->SetLabelSize(0.035);
   frp->GetXaxis()->SetTitleSize(0.035);
   frp->GetXaxis()->SetTitleFont(42);
   frp->GetYaxis()->SetTitle("#sigma(#delta#kappa) [fb]");
   frp->GetYaxis()->SetLabelFont(42);
   frp->GetYaxis()->SetLabelSize(0.035);
   frp->GetYaxis()->SetTitleSize(0.035);
   frp->GetYaxis()->SetTitleFont(42);
   frp->GetZaxis()->SetLabelSize(0.035);
   frp->GetZaxis()->SetTitleSize(0.035);
   frp->GetZaxis()->SetTitleFont(42);
   grmp->SetHistogram(frp);
   gr0p->SetHistogram(frp);
   grpp->SetHistogram(frp);

   grpp->Draw("apc");
   gr0p->Draw("pc same");
   grmp->Draw("pc same");
#else
   // Sensitivity plot
      if (y2 == 0) {
         ym[np] = 0;
         yp[np] = 0;
      } else {
         double L = 2000.; // [fb^-1]
         ym[np] = TMath::Abs(y1-y2)/TMath::Sqrt(y1/L);
         yp[np] = TMath::Abs(y3-y2)/TMath::Sqrt(y3/L);
      }
      np++;
   };
   TGraph *grmp = new TGraph(np, eaa, ym);
   grmp->SetName("km1");
   grmp->SetTitle("");
   grmp->SetFillColor(1);
   grmp->SetMarkerColor(2);
   grmp->SetMarkerStyle(20);
   TGraph *grpp = new TGraph(np, eaa, yp);
   grpp->SetName("kp1");
   grpp->SetTitle("");
   grpp->SetFillColor(1);
   grpp->SetMarkerColor(4);
   grpp->SetMarkerStyle(20);

   TH1F *frp = new TH1F("frp","",100,164,1076);
   frp->SetMinimum(0);
   frp->SetMaximum(27);
   frp->SetDirectory(0);
   frp->SetStats(0);
   frp->GetXaxis()->SetTitle("E_{#gamma#gamma} [GeV]");
   frp->GetXaxis()->SetRange(2,92);
   frp->GetXaxis()->SetLabelFont(42);
   frp->GetXaxis()->SetLabelSize(0.035);
   frp->GetXaxis()->SetTitleSize(0.035);
   frp->GetXaxis()->SetTitleFont(42);
   frp->GetYaxis()->SetTitle("Sensitivity");
   frp->GetYaxis()->SetLabelFont(42);
   frp->GetYaxis()->SetLabelSize(0.035);
   frp->GetYaxis()->SetTitleSize(0.035);
   frp->GetYaxis()->SetTitleFont(42);
   frp->GetZaxis()->SetLabelSize(0.035);
   frp->GetZaxis()->SetTitleSize(0.035);
   frp->GetZaxis()->SetTitleFont(42);
   grmp->SetHistogram(frp);
   grpp->SetHistogram(frp);

   grpp->Draw("apc");
   grmp->Draw("pc same");

   TLatex *   tex = new TLatex(535,13,"#delta#kappa = -1");
   tex->SetTextColor(2);
   tex->SetLineWidth(2);
   tex->Draw();

   tex = new TLatex(450,22.5,"#delta#kappa = +1");
   tex->SetTextColor(4);
   tex->SetLineWidth(2);
   tex->Draw();

   TArrow *arrow = new TArrow(435.3476,22.88742,292.207,20.98758,0.03,"|>");
   arrow->SetFillColor(4);
   arrow->SetFillStyle(1001);
   arrow->SetLineColor(4);
   arrow->SetAngle(40);
   arrow->Draw();
   arrow = new TArrow(523.8881,13.55588,367.4665,12.82947,0.03,"|>");
   arrow->SetFillColor(2);
   arrow->SetFillStyle(1001);
   arrow->SetLineColor(2);
   arrow->SetAngle(40);
   arrow->Draw();
   c1->Modified();
#endif
}
