***************************************************************
c
c     H H Production from Gamma Gamma Annihilation
c     distributed version (2008 July 8)
c     Shinya Kanemura (Univ. of Toyama)
c
c     Helicity amplitude 
c     amp_pp(s,t,u,mh,mt,mw,delkappa)
c     amp_pm(s,t,u,mh,mt,mw,delkappa)
c
c     Sub cross section  
c     subsig_pp(s,mh,mt,mw,delkappa)
c     subsig_pm(s,mh,mt,mw,delkappa)
c
c     Full cross section 
c     1. derivative cross section 
c     full_dsdc(x,ct,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
c     2. full total cross section
c     full_sigma(x,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
c
****************************************************************
      program       gamgamHH_send
      implicit none
csk
      integer i1,i,n,n1
      real*8 G_f,gw,mw,mz
      real*8 vpi,cw,cw2,sw2,c2w,gz,vev,mz2,mw2 
      real*8 bg,pi

      real*8     mu,m1sq,m2sq,m3sq,m4sq,p1sq,p2sq,p3sq,
     .           p4sq,p12sq,p23sq,s,t,u,theta
      complex*16 pole_w,delpole_w,boxpp_w,boxpm_w
      complex*16 vpole_w,vdelpole_w,vboxpp_w,vboxpm_w
      complex*16 pole_t,boxpp_t,boxpm_t
      complex*16 vpole_t,vboxpp_t,vboxpm_t

      real*8 dsdt_pp,dsdt_pm
      real*8 vdsdt_pp,vdsdt_pm

      real*8 mt,mh,delkappa

      Real*8 dsdc_pp,vdsdc_pp,ct
      real*8 dsdc_pm,vdsdc_pm

c      real*8 a,b,h,sum,x,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11      
c     integer j, n, i, k, no
c      real*8 tmin,tmax

      real*8 dLdtaudsdc,vdLdtaudsdc,tau,lam1,lam2,xi12
      real*8 subs,x,taumin,taumax,ym

      real*8 full_dsdc,vfull_dsdc
      real*8 full_sigma,vfull_sigma
      real*8 subsig_pp,vsubsig_pp
      real*8 subsig_pm,vsubsig_pm,vsubsig_both

      real*8 le1,le2,xi1,xi2,pc1,pc2,xi,y,ys

      real*8 vdLdz,dLdtau,z,vdsdy,f
      real*8 Lgg

      real*8 epsilon,eeemin, eeemax

      real*8 vfull_sigma_p,vfull_sigma_m,lumi_gg,lumi,eff,
     .       sensitiv,vfull_sigma_0,vfull_sigma_mm,vfull_sigma_pp 
      real*8 vsub_sigma_m_pp, vsub_sigma_m_pm
      real*8 vsub_sigma_0_pp, vsub_sigma_0_pm
      real*8 vsub_sigma_p_pp, vsub_sigma_p_pm

      real*8 std,eee  !eee is the energy of ee system (E_ee)

      real*8 hanbetsu,c1,c2,c3,dk,fsigma
      real*8 sens_p,sens_m,dk1_p,dk1_m,dk2_p,dk2_m
      real*8 emin,emax,egg

      real*8 ee,xv,vxv

#if 1
      real*8    sh
      integer*4 irtau, nrtau
      real*8    rtaumin, rtaumax, drtau, rtau, dLdrtau
      real*8    Lggtot, Lggeff
      external  Lgg
      real*8    Lgg
#endif

c$$$      dimension    x0(1000)
c$$$      external dsdt_pp
c$$$      external dsdt_pm
      

      call ffini

c$$$      open(1,file='tmp1.dat',form='formatted',status='unknown')
c$$$      open(2,file='tmp2.dat',form='formatted',status='unknown')
c$$$      open(3,file='tmp3.dat',form='formatted',status='unknown')
c$$$      open(4,file='tmp4.dat',form='formatted',status='unknown')
c$$$      open(5,file='tmp5.dat',form='formatted',status='unknown')
c$$$      open(6,file='tmp6.dat',form='formatted',status='unknown')
      open(21,file='lum.dat',form='formatted',status='unknown')

ccccccccccccccccc SM parameters cccccccccccccccccccc      
      include 'constants.f' 
      
csk

      eff=100.d0   ! Efficiency
      lumi=1000.d0 ! Luminosity for e+e-

*     s=500.d0**2  ! Energy^2 of e+ e- collision
      s=363.d0**2  ! Energy^2 of e+ e- collision
      mt=175.d0     
      mh=120.d0

      lumi_gg=lumi/3.d0 ! Effective gamgam Luminosity

      theta=vpi/2.d0
      ct=dcos(theta)

c      x=2.69
      x=4.8
       pc1=-1.d0  ! polarization of initial laser 1
       pc2=-1.d0  ! polarization of initial laser 2
      lam1=0.45d0 ! polarization of initial electron 1
      lam2=0.45d0 ! polarization of initial electron 2

ccccc
c      unpolarized case
c      xi12=0.d0
ccccc
      epsilon=10.d0**(-6)
      taumin=4.d0*mh**2/s
c      write(*,*) ym,ys

      lam1=0.45d0
      lam2=0.45d0
      pc1=-1.d0
      pc2=-1.d0
      n=10
c      write(*,*)  'lam1,lam2,pc1,pc2=',lam1,lam2,pc1,pc2

ccccccccccccccccccccccccccccccccccccccccc
cccc  Sensitivity without linear approx.  cccc
ccccccccccccccccccccccccccccccccccccccccc

c      n=6
c
c      s=500.d0**2
c
c      ee=dsqrt(s)/2.d0
c      vxv=xv(ee)
c      x=vxv
c      ym=x/(1.d0+x)
c      ys=taumin/ym
c
c      write(*,*) x,lam1,lam2,s,mt,mw 

      mh=120.d0
#if 1      
      sh = 300.d0**2

      delkappa=-1.d0
      vsub_sigma_m_pp = subsig_pp(sh,mh,mt,mw,delkappa)
      vsub_sigma_m_pm = subsig_pm(sh,mh,mt,mw,delkappa)
      delkappa= 0.d0
      vsub_sigma_0_pp = subsig_pp(sh,mh,mt,mw,delkappa)
      vsub_sigma_0_pm = subsig_pm(sh,mh,mt,mw,delkappa)
      delkappa=+1.d0
      vsub_sigma_p_pp = subsig_pp(sh,mh,mt,mw,delkappa)
      vsub_sigma_p_pm = subsig_pm(sh,mh,mt,mw,delkappa)

      write(*,*) '(',sh,mh,vsub_sigma_m_pp, vsub_sigma_m_pm
      write(*,*) '(',sh,mh,vsub_sigma_0_pp, vsub_sigma_0_pm
      write(*,*) '(',sh,mh,vsub_sigma_p_pp, vsub_sigma_p_pm
#else
      delkappa=-1.d0
      vfull_sigma_m=full_sigma(
     .     x,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
      delkappa=0.0d0
      vfull_sigma_0=full_sigma(
     .     x,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
      delkappa=+1.0d0
      vfull_sigma_p=full_sigma(
     .     x,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)

      write(*,*) mh,vfull_sigma_m
      write(*,*) mh,vfull_sigma_0
      write(*,*) mh,vfull_sigma_p
#endif
#if 1
      ym=x/(1.d0+x)
      taumax=ym**2
      Lggtot = Lgg(x,1.d-4,taumax,lam1,lam2,pc1,pc2)
      Lggeff = Lgg(x,taumin,taumax,lam1,lam2,pc1,pc2)
      print *, '(Lgg(> th)=', Lggeff 
      print *, '(Lgg(total)=', Lggtot

      print *, 'new frame'
      print *, 'set limits x 0 1 y 0 3'
      print *, '(taumin = ', taumin, ' taumax=', taumax
      print *, 'set order x dummy y'
      print *, ' 0. 0. 0.'
      write(21,'(3e15.5)') 0., 0., 0.

      nrtau=200

*     rtaumin=sqrt(taumin)
      rtaumin=1.d-2
      rtaumax=sqrt(taumax)
      drtau=(rtaumax-rtaumin)/nrtau
      do 666 irtau=0,nrtau
        rtau = rtaumin + irtau*drtau
        tau  = rtau**2
        if (irtau .eq. nrtau) tau=taumax
*       dLdrtau = dLdtau(x,tau,lam1,lam2,pc1,pc2)*2*rtau
        dLdrtau = dLdtau(x,tau,lam1,lam2,pc1,pc2)*2*rtau/Lggtot
        print *, rtau,' ', tau,' ', dLdrtau
        write(21,'(3e15.5)') rtau, tau, dLdrtau
 666  continue

      print *, 'join'
      print *, '(That''s it'
#endif

c$$$      n=12
c$$$      mh=200.d0
c$$$      write(*,*) x,lam1,lam2,xi12,s,mt,mw 
c$$$c      do 12 i=0,n
c$$$c      mh=100.d0+(dsqrt(s)/2.d0*0.8d0-epsilon-100.d0)/dble(n)*dble(i)
c$$$      eee=550.d0
c$$$      s=eee**2
c$$$      delkappa=-1.d0
c$$$      vfull_sigma_m=full_sigma(
c$$$     .     x,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
c$$$      delkappa=0.d0
c$$$      vfull_sigma_0=full_sigma(
c$$$     .     x,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
c$$$      delkappa=+1.d0
c$$$      vfull_sigma_p=full_sigma(
c$$$     .     x,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
c$$$      c1=(vfull_sigma_p+vfull_sigma_m-2.d0*vfull_sigma_0)/2.d0
c$$$      c2=(vfull_sigma_p-vfull_sigma_m)/2.d0
c$$$      c3=vfull_sigma_0
c$$$c$$$      do 88 n1=0,100
c$$$c$$$         dk=-1.d0+n1*(1.d0-(-1.d0))/100.d0
c$$$c$$$         fsigma=c1*dk**2+c2*dk+c3
c$$$c$$$         write(1,*)  dk, fsigma 
c$$$c$$$ 88   continue
c$$$      dk1_m=(-c2-dsqrt(c2**2+4.d0*c1*dsqrt(c3/lumi_gg)))/2.d0/c1
c$$$      dk1_p=(-c2+dsqrt(c2**2+4.d0*c1*dsqrt(c3/lumi_gg)))/2.d0/c1
c$$$      hanbetsu=c2**2-4.d0*c1*dsqrt(c3/lumi_gg)
c$$$      if (hanbetsu.lt.0.d0) then 
c$$$         dk2_m=-10.d0**10
c$$$         dk2_p=+10.d0**10
c$$$         sens_p=dabs(dk1_p)
c$$$         sens_m=dabs(dk1_m)
c$$$      else       
c$$$         dk2_m=(-c2-dsqrt(c2**2-4.d0*c1*dsqrt(c3/lumi_gg)))/2.d0/c1
c$$$         dk2_p=(-c2+dsqrt(c2**2-4.d0*c1*dsqrt(c3/lumi_gg)))/2.d0/c1
c$$$         if (dk2_m.gt.0.d0) then
c$$$            sens_p=min(dabs(dk1_p),dabs(dk2_m))
c$$$            sens_m=dabs(dk1_m)
c$$$         elseif (dk2_p.lt.0.d0) then 
c$$$            sens_p=dabs(dk1_p)
c$$$            sens_m=min(dabs(dk1_m),dabs(dk2_p))
c$$$         else 
c$$$            sens_p=min(dabs(dk1_p),dabs(dk2_p))
c$$$            sens_m=min(dabs(dk1_m),dabs(dk2_m))
c$$$         endif
c$$$      endif
c$$$      sens_m=sens_m*100.d0 ! percent
c$$$      sens_p=sens_p*100.d0 ! percent
c$$$      write(*,*) eee,sens_m,sens_p
c$$$      write(1,*) eee,sens_m
c$$$      write(2,*) eee,sens_p
c$$$c 12    continue

c$$$ccccccccccccccccccccccccccccccccccccccccc
c$$$cccc  Sensitivity without linear approx.  cccc
c$$$ccccccccccccccccccccccccccccccccccccccccc
c$$$      n=12
c$$$
c$$$      s=300.d0**2
c$$$      write(*,*) x,lam1,lam2,xi12,s,mt,mw 
c$$$      do 12 i=0,n
c$$$      mh=100.d0+(dsqrt(s)/2.d0*0.8d0-epsilon-100.d0)/dble(n)*dble(i)
c$$$      delkappa=-1.d0
c$$$      vfull_sigma_m=full_sigma(
c$$$     .     x,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
c$$$      delkappa=0.d0
c$$$      vfull_sigma_0=full_sigma(
c$$$     .     x,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
c$$$      delkappa=+1.d0
c$$$      vfull_sigma_p=full_sigma(
c$$$     .     x,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
c$$$      c1=(vfull_sigma_p+vfull_sigma_m-2.d0*vfull_sigma_0)/2.d0
c$$$      c2=(vfull_sigma_p-vfull_sigma_m)/2.d0
c$$$      c3=vfull_sigma_0
c$$$c$$$      do 88 n1=0,100
c$$$c$$$         dk=-1.d0+n1*(1.d0-(-1.d0))/100.d0
c$$$c$$$         fsigma=c1*dk**2+c2*dk+c3
c$$$c$$$         write(1,*)  dk, fsigma 
c$$$c$$$ 88   continue
c$$$      dk1_m=(-c2-dsqrt(c2**2+4.d0*c1*dsqrt(c3/lumi_gg)))/2.d0/c1
c$$$      dk1_p=(-c2+dsqrt(c2**2+4.d0*c1*dsqrt(c3/lumi_gg)))/2.d0/c1
c$$$      hanbetsu=c2**2-4.d0*c1*dsqrt(c3/lumi_gg)
c$$$      if (hanbetsu.lt.0.d0) then 
c$$$         dk2_m=-10.d0**10
c$$$         dk2_p=+10.d0**10
c$$$         sens_p=dabs(dk1_p)
c$$$         sens_m=dabs(dk1_m)
c$$$      else       
c$$$         dk2_m=(-c2-dsqrt(c2**2-4.d0*c1*dsqrt(c3/lumi_gg)))/2.d0/c1
c$$$         dk2_p=(-c2+dsqrt(c2**2-4.d0*c1*dsqrt(c3/lumi_gg)))/2.d0/c1
c$$$         if (dk2_m.gt.0.d0) then
c$$$            sens_p=min(dabs(dk1_p),dabs(dk2_m))
c$$$            sens_m=dabs(dk1_m)
c$$$         elseif (dk2_p.lt.0.d0) then 
c$$$            sens_p=dabs(dk1_p)
c$$$            sens_m=min(dabs(dk1_m),dabs(dk2_p))
c$$$         else 
c$$$            sens_p=min(dabs(dk1_p),dabs(dk2_p))
c$$$            sens_m=min(dabs(dk1_m),dabs(dk2_m))
c$$$         endif
c$$$      endif
c$$$      sens_m=sens_m*100.d0 ! percent
c$$$      sens_p=sens_p*100.d0 ! percent
c$$$      write(*,*) mh,sens_m,sens_p
c$$$      write(1,*) mh,sens_m
c$$$      write(2,*) mh,sens_p
c$$$ 12    continue
csk
      stop 
      end       

      real*8 function ftmp(x)
      implicit none
      real*8 x
      ftmp=x**2
      return
      end 

      real*8 function bg(s,mg2,mw2) 
      implicit none
      real*8 s,mg2,mw2 
      bg = dsqrt(1.d0 -2.d0*(mg2 + mw2)/s +(mg2 - mw2)**2/s**2 )
      return 
      end


cccccccc value of x cccccccc 
      real*8 function xv(ee)
      implicit none
      real*8 ee,vpi,c,hbar,me,lambda,omega
      lambda=1.d0*10.d0**(-6.d0)
      me=0.511d0*10d0**(6.d0)
      vpi=3.141592d0
      omega=2.d0*vpi*(197.327d0*10.d0**(-9.d0))/lambda
      xv=4.d0*(ee*10.d0**(9.d0))*omega/me**2
      return
      end 

ccccccccccccccccccccc  Section1: Functions ccccccccccccccccccccccccccc

*     **********************************************************
*          Def of Integral Functions
*     **********************************************************
      double complex function af(mu,m2)
      implicit none 
      complex*16  ca0
      real*8      mu,m2    
      real*8      d0,xmu,xm
      integer     ier
      d0  = 0d0
      xmu = mu
      xm =  m2
      ier = 10
      call ffxa0(ca0,d0,xmu,xm,ier)
      af=ca0
      return
      end      

      double complex function b0f(mu,q2,x2,y2)
      implicit none 
      real*8     mu, q2, x2, y2    
      real*8     d0, xmu, xk, xma, xmb
      complex*16 cb0
      integer    ier
      d0  = 0d0
      xmu = mu
      xk  = q2
      xma = x2
      xmb = y2
      ier = 10
      call ffxb0(cb0,d0,xmu,xk,xma,xmb,ier)
      b0f=cb0
      return
      end

      double complex function c0f(p2,q2,s,x2,y2,z2)
      implicit none 
      real*8     x2,y2,z2,s,p2,q2    
      real*8     xpi(6)
      complex*16 cc0
      integer    ier
      xpi(1) = x2
      xpi(2) = y2
      xpi(3) = z2
      xpi(4) = p2
      xpi(5) = q2
      xpi(6) = s
      ier    = 10
      call ffxc0(cc0,xpi,ier)
      c0f=cc0   
      return
      end

      double complex function d0f( 
     .         p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      implicit none 
      double complex cd0
      real*8     xpi(13)
      real*8     p12,p22,p32,p42,p122,p232,m12,m22,m32,m42
      integer    ier
      ier    =  10
      xpi(1) = m12
      xpi(2) = m22
      xpi(3) = m32
      xpi(4) = m42
      xpi(5) = p12
      xpi(6) = p22
      xpi(7) = p32
      xpi(8) = p42
      xpi(9)  = p122 
      xpi(10) = p232 
      xpi(11) = 0.d0
      xpi(12) = 0.d0
      xpi(13) = 0.d0
      call ffxd0(cd0,xpi,ier)
      d0f=cd0   
      return
      end

cccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      double complex function b1f(mu,q2,x2,y2)
      implicit none 
      real*8     mu, q2, x2, y2   
      complex*16 af, b0f
      b1f = 1.d0/(2.d0 * q2) * 
     &      ( af(mu,x2) - af(mu,y2) 
     &         + (y2 - x2 - q2) * b0f(mu,q2,x2,y2) ) 
      return
      end

      double complex function b21f(mu,q2,x2,y2)
      implicit none 
      complex*16    af, b0f 
      complex*16    avx, avy, b0v 
      real*8        mu, q2, x2, y2    
      avx =  af(mu,x2)  
      avy =  af(mu,y2)  
      b0v = b0f(mu,q2,x2,y2)  
      b21f = 1.d0/(3.d0 * q2**2) * ( 
     &            (y2 - x2 - q2) * avx  
     &          - (y2 - x2 - q2 - 2.d0 * q2) * avy
     &          + (y2 - x2 - q2)**2 * b0v  
     &          - q2 * ( avy + x2 * b0v) )   
      return
      end

      double complex function b22f(mu,q2,x2,y2)
      implicit none 
      complex*16    af, b0f 
      complex*16    avx, avy, b0v 
      real*8        mu, q2, x2, y2    
      avx =  af(mu,x2)  
      avy =  af(mu,y2)  
      b0v = b0f(mu,q2,x2,y2)  
      b22f = 1.d0/3.d0 * ( 
     &          avy + x2 * b0v 
     &        - 1.d0/(4.d0 * q2) *(
     &            (y2 - x2 - q2) * avx  
     &          - (y2 - x2 - q2 - 2.d0 * q2) * avy
     &          + (y2 - x2 - q2)**2 * b0v  )   )
      return
      end

      double complex function c11f(mu,p2,q2,s,x2,y2,z2)
      implicit none 
      complex*16    b0f,c0f
      complex*16    b0xz,c0v
      real*8        mu,p2,q2,s,x2,y2,z2   
      b0xz = b0f(mu,s,x2,z2)
      c0v = c0f(p2,q2,s,x2,y2,z2)
      c11f= 1.d0/(4.d0*p2*q2 - (s - p2 - q2)**2 ) * 
     &    (  2.d0*q2 *
     &         ( b0xz - b0f(mu,q2,y2,z2)  
     &           +(y2 - x2 - p2) * c0v )
     &      -(s - p2 - q2) * 
     &         ( b0f(mu,p2,x2,y2) - b0xz 
     &           +(z2 - y2 - s + p2)*  c0v ))
      return
      end

      double complex function c12f(mu,p2,q2,s,x2,y2,z2)
      implicit none 
      complex*16    b0f,c0f
      complex*16    b0xz,c0v
      real*8        mu,p2,q2,s,x2,y2,z2    
      b0xz = b0f(mu,s,x2,z2)
      c0v = c0f(p2,q2,s,x2,y2,z2)
      c12f= 1.d0/(4.d0*p2*q2 - (s - p2 - q2)**2 ) * 
     &    ( -(s - p2 - q2)*
     &         ( b0xz - b0f(mu,q2,y2,z2)  
     &           +(y2 - x2 - p2) * c0v )
     &      +2.d0*p2 *
     &         ( b0f(mu,p2,x2,y2) - b0xz 
     &           +(z2 - y2 - s + p2)*  c0v ))
      return
      end

      double complex function c24f(mu,p2,q2,s,x2,y2,z2)
      implicit none 
      complex*16    b0f,c0f,c11f,c12f
      real*8        mu,p2,q2,s,x2,y2,z2    
      c24f =  1.d0/4.d0 + 1.d0/4.d0 * b0f(mu,q2,y2,z2) + 
     &       x2/2.d0 * c0f(p2,q2,s,x2,y2,z2) - 
     &       (y2 - x2 - p2)/4.d0 * c11f(mu,p2,q2,s,x2,y2,z2) - 
     &       (z2 - y2 - s + p2)/4.d0 *  c12f(mu,p2,q2,s,x2,y2,z2)
      return
      end

      double complex function c23f(mu,p2,q2,s,x2,y2,z2)
      implicit none 
      complex*16    b0f,b1f,c11f,c24f
      complex*16    b1xz, c11v
      real*8        mu,p2,q2,s,x2,y2,z2    
      b1xz = b1f(mu,s,x2,z2)
      c11v = c11f(mu,p2,q2,s,x2,y2,z2)
      c23f= 1.d0/(4.d0*p2*q2 - (s - p2 - q2)**2 ) * 
     &    ( -(s - p2 - q2)*
     &         ( b1xz + b0f(mu,q2,y2,z2)  
     &           + (y2 - x2 - p2) * c11v
     &           - 2.d0 * c24f(mu,p2,q2,s,x2,y2,z2)                )
     &      + 2.d0*p2 *
     &         ( b1f(mu,p2,x2,y2) - b1xz 
     &           + (z2 - y2 - s + p2) * c11v ))
      return
      end

      double complex function c21f(mu,p2,q2,s,x2,y2,z2)
      implicit none 
      complex*16    b0f,b1f,c11f,c24f
      complex*16    b1xz,c11v
      real*8        mu,p2,q2,s,x2,y2,z2    
      b1xz = b1f(mu,s,x2,z2)
      c11v = c11f(mu,p2,q2,s,x2,y2,z2)
      c21f= 1.d0/(4.d0*p2*q2 - (s - p2 - q2)**2 ) * 
     &    (  + 2.d0*q2 *
     &         ( b1xz + b0f(mu,q2,y2,z2)  
     &           + (y2 - x2 - p2) * c11v
     &           - 2.d0 * c24f(mu,p2,q2,s,x2,y2,z2)                )
     &       -(s - p2 - q2)*
     &         ( b1f(mu,p2,x2,y2) - b1xz 
     &           + (z2 - y2 - s + p2) * c11v ))
      return
      end

      double complex function     c22f(mu,p2,q2,s,x2,y2,z2)
      implicit none 
      complex*16    b1f,c12f,c24f
      complex*16    b1xz, c12v
      real*8        mu,p2,q2,s,x2,y2,z2    
      b1xz = b1f(mu,s,x2,z2)
      c12v = c12f(mu,p2,q2,s,x2,y2,z2)
      c22f= 1.d0/(4.d0*p2*q2 - (s - p2 - q2)**2 ) * 
     &    ( - (s - p2 - q2)
     &        * ( b1xz - b1f(mu,q2,y2,z2) 
     &           + (y2 - x2 - p2) * c12v )
     &      + 2.d0 * p2  
     &        * ( - b1xz   
     &           +(z2 - y2 - s + p2) * c12v
     &           - 2.d0 * c24f(mu,p2,q2,s,x2,y2,z2)            ))
      return
      end


ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
cccccccccccccccccc  D-function coefficients ccccccccccccccccccccccccccc
cccccccc            comfirmed with Oliver  May00           cccccccccccc
ccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      complex*16 function d11f(  
     .       p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      implicit none 
      real*8    p12,p22,p32,p42,p122,p232,m12,m22,m32,m42
      real*8    f1, f2, f3
      complex*16 a1, a2, a3
      real*8    x11,x12,x13,x21,x22,x23,x31,x32,x33
      real*8    i11,i12,i13,i21,i22,i23,i31,i32,i33
      real*8    det33, dp1p2, dp2p3, dp3p1
      complex*16   c0f, d0f
      complex*16   c0_123, c0_124, c0_134, c0_234, d0v

      c0_123 = c0f(p12,  p22,  p122,  m12, m22, m32) 
      c0_124 = c0f(p12,  p232, p42,  m12, m22, m42)
      c0_134 = c0f(p122, p32,  p42,  m12, m32, m42)
      c0_234 = c0f(p22,  p32,  p232, m22, m32, m42)
      d0v    = d0f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)

      f1 = m22 - m12 - p12
      f2 = m32 - m22 - p122 + p12
      f3 = m42 - m32 - p42  + p122

      a1 = c0_134 - c0_234 + f1 * d0v 
      a2 = c0_124 - c0_134 + f2 * d0v 
      a3 = c0_123 - c0_124 + f3 * d0v 

      dp1p2 = p122 - p12 - p22 
      dp2p3 = p232 - p22 - p32 
      dp3p1 = p42  - p12 - p22 - p32 - dp1p2 - dp2p3

      x11 = 2.d0 * p12  
      x12 = dp1p2  
      x13 = dp3p1  
      x21 = dp1p2  
      x22 = 2.d0 * p22  
      x23 = dp2p3  
      x31 = dp3p1  
      x32 = dp2p3  
      x33 = 2.d0 * p32  

      det33 = -x13 * x22 * x31 +x12 * x23 * x31 +x13 * x21 * x32 
     &        -x11 * x23 * x32 -x12 * x21 * x33 +x11 * x22 * x33

      i11 = - x23 * x32 + x22 * x33
      i12 = + x13 * x32 - x12 * x33
      i13 = - x13 * x22 + x12 * x23
      i21 = + x23 * x31 - x21 * x33
      i22 = - x13 * x31 + x11 * x33
      i23 = + x13 * x21 - x11 * x23
      i31 = - x22 * x31 + x21 * x32
      i32 = + x12 * x31 - x11 * x32
      i33 = - x12 * x21 + x11 * x22

      d11f = 1.d0/det33 * (i11 * a1 + i12 * a2 + i13 * a3) 
      return
      end

      complex*16 function d12f( 
     .        p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      implicit none 

      real*8    p12,p22,p32,p42,p122,p232,m12,m22,m32,m42
      real*8    f1, f2, f3
      complex*16 a1, a2, a3
      real*8    x11,x12,x13,x21,x22,x23,x31,x32,x33
      real*8    i11,i12,i13,i21,i22,i23,i31,i32,i33
      real*8    det33,   dp1p2, dp2p3, dp3p1
      complex*16   c0f, d0f
      complex*16   c0_123, c0_124, c0_134, c0_234, d0v

      c0_123 = c0f(p12,  p22,  p122,  m12, m22, m32) 
      c0_124 = c0f(p12,  p232, p42,  m12, m22, m42)
      c0_134 = c0f(p122, p32,  p42,  m12, m32, m42)
      c0_234 = c0f(p22,  p32,  p232, m22, m32, m42)
      d0v = d0f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)

      f1 = m22 - m12 - p12
      f2 = m32 - m22 - p122 + p12
      f3 = m42 - m32 - p42  + p122
      a1 = c0_134 - c0_234 + f1 * d0v 
      a2 = c0_124 - c0_134 + f2 * d0v 
      a3 = c0_123 - c0_124 + f3 * d0v 
      dp1p2 = p122 - p12 - p22 
      dp2p3 = p232 - p22 - p32 
      dp3p1 = p42 - p12 - p22 - p32 - dp1p2 - dp2p3

      x11 = 2.d0 * p12  
      x12 = dp1p2  
      x13 = dp3p1  
      x21 = dp1p2  
      x22 = 2.d0 * p22  
      x23 = dp2p3  
      x31 = dp3p1  
      x32 = dp2p3  
      x33 = 2.d0 * p32  

      det33 = -x13 * x22 * x31 + x12 * x23 * x31 + x13 * x21 * x32 
     &       - x11 * x23 * x32 - x12 * x21 * x33 + x11 * x22 * x33

      i11 = - x23 * x32 + x22 * x33
      i12 = + x13 * x32 - x12 * x33
      i13 = - x13 * x22 + x12 * x23
      i21 = + x23 * x31 - x21 * x33
      i22 = - x13 * x31 + x11 * x33
      i23 = + x13 * x21 - x11 * x23
      i31 = - x22 * x31 + x21 * x32
      i32 = + x12 * x31 - x11 * x32
      i33 = - x12 * x21 + x11 * x22
      d12f = 1.d0/det33 * (i21 * a1 + i22 * a2 + i23 * a3 ) 
      return
      end

      complex*16 function d13f( 
     .      p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      implicit none 
      real*8    p12,p22,p32,p42,p122,p232,m12,m22,m32,m42
      real*8    f1, f2, f3
      complex*16 a1, a2, a3
      real*8    x11,x12,x13,x21,x22,x23,x31,x32,x33
      real*8    i11,i12,i13,i21,i22,i23,i31,i32,i33
      real*8    det33,      dp1p2,dp2p3,dp3p1
      complex*16   c0f, d0f
      complex*16   c0_123, c0_124, c0_134, c0_234, d0v
      c0_123 = c0f(p12,  p22,  p122,  m12, m22, m32) 
      c0_124 = c0f(p12,  p232, p42,  m12, m22, m42)
      c0_134 = c0f(p122, p32,  p42,  m12, m32, m42)
      c0_234 = c0f(p22,  p32,  p232, m22, m32, m42)
      d0v = d0f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      f1 = m22 - m12 - p12
      f2 = m32 - m22 - p122 + p12
      f3 = m42 - m32 - p42  + p122
      a1 = c0_134 - c0_234 + f1 * d0v 
      a2 = c0_124 - c0_134 + f2 * d0v 
      a3 = c0_123 - c0_124 + f3 * d0v 
      dp1p2 = p122 - p12 - p22 
      dp2p3 = p232 - p22 - p32 
      dp3p1 = p42 - p12 - p22 - p32 - dp1p2 - dp2p3

      x11 = 2.d0 * p12  
      x12 = dp1p2  
      x13 = dp3p1  
      x21 = dp1p2  
      x22 = 2.d0 * p22  
      x23 = dp2p3  
      x31 = dp3p1  
      x32 = dp2p3  
      x33 = 2.d0 * p32  

      det33 = -x13 * x22 * x31 +x12 * x23 * x31 +x13 * x21 * x32 
     &       - x11 * x23 * x32 -x12 * x21 * x33 +x11 * x22 * x33  
      i11 = - x23 * x32 + x22 * x33
      i12 = + x13 * x32 - x12 * x33
      i13 = - x13 * x22 + x12 * x23
      i21 = + x23 * x31 - x21 * x33
      i22 = - x13 * x31 + x11 * x33
      i23 = + x13 * x21 - x11 * x23
      i31 = - x22 * x31 + x21 * x32
      i32 = + x12 * x31 - x11 * x32
      i33 = - x12 * x21 + x11 * x22

      d13f = 1.d0/det33 * (i31 * a1 + i32 * a2 + i33 * a3 ) 

      return
      end


      complex*16 function d27f( 
     .    p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      implicit none 
      real*8    p12,p22,p32,p42,p122,p232,m12,m22,m32,m42
      real*8    f1, f2, f3
      complex*16   c0f, d0f, d11f, d12f, d13f
      complex*16   c0_234, d0v, d11, d12, d13
      c0_234 = c0f(p22,  p32,  p232, m22, m32, m42)
      d0v = d0f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      d11 = d11f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      d12 = d12f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      d13 = d13f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      f1 = m22 - m12 - p12
      f2 = m32 - m22 - p122 + p12
      f3 = m42 - m32 - p42  + p122
      d27f = m12 * d0v + c0_234/2.d0 
     &        -(f1 * d11 + f2 * d12 + f3 * d13)/2.d0
      return
      end

      complex*16 function d21f(mu, 
     .         p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      implicit none 
      real*8    mu,p12,p22,p32,p42,p122,p232,m12,m22,m32,m42
      real*8    f1, f2, f3
      complex*16 b1, b2, b3
      real*8    x11,x12,x13,x21,x22,x23,x31,x32,x33
      real*8    i11,i12,i13,i21,i22,i23,i31,i32,i33
      real*8    det33,      dp1p2,dp2p3,dp3p1
      complex*16   c0f, c11f, d11f, d27f
      complex*16   c11_123, c11_124, c11_134, c0_234, d11, d27

      c0_234  =  c0f(p22,  p32,  p232, m22, m32, m42)
      c11_123 = c11f(mu,p12,  p22,  p122,  m12, m22, m32) 
      c11_124 = c11f(mu,p12,  p232, p42,  m12, m22, m42)
      c11_134 = c11f(mu,p122, p32,  p42,  m12, m32, m42)
      d11 = d11f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      d27 = d27f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)

      f1 = m22 - m12 - p12
      f2 = m32 - m22 - p122 + p12
      f3 = m42 - m32 - p42  + p122
      b1 = c11_134 + c0_234  + f1 * d11 - 2.d0 * d27  
      b2 = c11_124 - c11_134 + f2 * d11 
      b3 = c11_123 - c11_124 + f3 * d11 
      dp1p2 = p122 - p12 - p22 
      dp2p3 = p232 - p22 - p32 
      dp3p1 = p42 - p12 - p22 - p32 - dp1p2 - dp2p3

      x11 = 2.d0 * p12  
      x12 = dp1p2  
      x13 = dp3p1  
      x21 = dp1p2  
      x22 = 2.d0 * p22  
      x23 = dp2p3  
      x31 = dp3p1  
      x32 = dp2p3  
      x33 = 2.d0 * p32  

      det33 = -x13 * x22 * x31 +x12 * x23 * x31 +x13 * x21 * x32 
     &        -x11 * x23 * x32 -x12 * x21 * x33 +x11 * x22 * x33  
      i11 = - x23 * x32 + x22 * x33
      i12 = + x13 * x32 - x12 * x33
      i13 = - x13 * x22 + x12 * x23
      i21 = + x23 * x31 - x21 * x33
      i22 = - x13 * x31 + x11 * x33
      i23 = + x13 * x21 - x11 * x23
      i31 = - x22 * x31 + x21 * x32
      i32 = + x12 * x31 - x11 * x32
      i33 = - x12 * x21 + x11 * x22
      d21f = 1.d0/det33 * (i11 *b1 + i12 *b2 + i13 *b3) 
      return
      end


      complex*16 function d24f(mu,
     .         p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      implicit none 
      real*8    mu,p12,p22,p32,p42,p122,p232,m12,m22,m32,m42
      real*8    f1, f2, f3
      complex*16 b1, b2, b3
      real*8    x11,x12,x13,x21,x22,x23,x31,x32,x33
      real*8    i11,i12,i13,i21,i22,i23,i31,i32,i33
      real*8    det33,      dp1p2,dp2p3,dp3p1
      complex*16   c0f, c11f, d11f, d27f
      complex*16   c11_123, c11_124, c11_134, c0_234, d11, d27
      c0_234  =  c0f(p22,  p32,  p232, m22, m32, m42)
      c11_123 = c11f(mu,p12,  p22,  p122,  m12, m22, m32) 
      c11_124 = c11f(mu,p12,  p232, p42,  m12, m22, m42)
      c11_134 = c11f(mu,p122, p32,  p42,  m12, m32, m42)
      d11 = d11f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      d27 = d27f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      f1 = m22 - m12 - p12
      f2 = m32 - m22 - p122 + p12
      f3 = m42 - m32 - p42  + p122
      b1 = c11_134 + c0_234  + f1 * d11 - 2.d0 * d27  
      b2 = c11_124 - c11_134 + f2 * d11 
      b3 = c11_123 - c11_124 + f3 * d11 
      dp1p2 = p122 - p12 - p22 
      dp2p3 = p232 - p22 - p32 
      dp3p1 = p42 - p12 - p22 - p32 - dp1p2 - dp2p3
      x11 = 2.d0 * p12  
      x12 = dp1p2  
      x13 = dp3p1  
      x21 = dp1p2  
      x22 = 2.d0 * p22  
      x23 = dp2p3  
      x31 = dp3p1  
      x32 = dp2p3  
      x33 = 2.d0 * p32 
      det33 =-x13 * x22 * x31 +x12 * x23 * x31 +x13 * x21 * x32 
     &       -x11 * x23 * x32 -x12 * x21 * x33 +x11 * x22 * x33 
      i11 = - x23 * x32 + x22 * x33
      i12 = + x13 * x32 - x12 * x33
      i13 = - x13 * x22 + x12 * x23
      i21 = + x23 * x31 - x21 * x33
      i22 = - x13 * x31 + x11 * x33
      i23 = + x13 * x21 - x11 * x23
      i31 = - x22 * x31 + x21 * x32
      i32 = + x12 * x31 - x11 * x32
      i33 = - x12 * x21 + x11 * x22
      d24f = 1.d0/det33 * (i21 *b1 + i22 *b2 + i23 *b3) 
      return
      end

      complex*16 function d25f(mu,
     .         p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      implicit none 
      real*8    mu,p12,p22,p32,p42,p122,p232,m12,m22,m32,m42
      real*8    f1, f2, f3
      complex*16 b1, b2, b3
      real*8    x11,x12,x13,x21,x22,x23,x31,x32,x33
      real*8    i11,i12,i13,i21,i22,i23,i31,i32,i33
      real*8    det33,      dp1p2,dp2p3,dp3p1
      complex*16   c0f, c11f, d11f, d27f
      complex*16   c11_123, c11_124, c11_134, c0_234, d11, d27
      c0_234  =  c0f(p22,  p32,  p232, m22, m32, m42)
      c11_123 = c11f(mu,p12,  p22,  p122,  m12, m22, m32) 
      c11_124 = c11f(mu,p12,  p232, p42,  m12, m22, m42)
      c11_134 = c11f(mu,p122, p32,  p42,  m12, m32, m42)
      d11 = d11f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      d27 = d27f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      f1 = m22 - m12 - p12
      f2 = m32 - m22 - p122 + p12
      f3 = m42 - m32 - p42  + p122
      b1 = c11_134 + c0_234  + f1 * d11 - 2.d0 * d27  
      b2 = c11_124 - c11_134 + f2 * d11 
      b3 = c11_123 - c11_124 + f3 * d11 
      dp1p2 = p122 - p12 - p22 
      dp2p3 = p232 - p22 - p32 
      dp3p1 = p42 - p12 - p22 - p32 - dp1p2 - dp2p3
      x11 = 2.d0 * p12  
      x12 = dp1p2  
      x13 = dp3p1  
      x21 = dp1p2  
      x22 = 2.d0 * p22  
      x23 = dp2p3  
      x31 = dp3p1  
      x32 = dp2p3  
      x33 = 2.d0 * p32  
      det33 = -x13 * x22 * x31 + x12 * x23 * x31 + x13 * x21 * x32 
     &       - x11 * x23 * x32 - x12 * x21 * x33 + x11 * x22 * x33     
      i11 = - x23 * x32 + x22 * x33
      i12 = + x13 * x32 - x12 * x33
      i13 = - x13 * x22 + x12 * x23
      i21 = + x23 * x31 - x21 * x33
      i22 = - x13 * x31 + x11 * x33
      i23 = + x13 * x21 - x11 * x23
      i31 = - x22 * x31 + x21 * x32
      i32 = + x12 * x31 - x11 * x32
      i33 = - x12 * x21 + x11 * x22
      d25f = 1.d0/det33 * (i31 *b1 + i32 *b2 + i33 * b3) 
      return
      end

      complex*16 function d22f(mu,
     .         p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      implicit none 
      real*8    mu,p12,p22,p32,p42,p122,p232,m12,m22,m32,m42
      real*8    f1, f2, f3
      complex*16 r1, r2, r3
      real*8    x11,x12,x13,x21,x22,x23,x31,x32,x33
      real*8    i11,i12,i13,i21,i22,i23,i31,i32,i33
      real*8    det33,      dp1p2,dp2p3,dp3p1
      complex*16   c11f, c12f, d12f, d27f
      complex*16   c12_123, c12_124, c11_134, c11_234, d12, d27
      c11_234 = c11f(mu,p22,  p32,  p232, m22, m32, m42)
      c12_123 = c12f(mu,p12,  p22,  p122,  m12, m22, m32) 
      c12_124 = c12f(mu,p12,  p232, p42,  m12, m22, m42)
      c11_134 = c11f(mu,p122, p32,  p42,  m12, m32, m42)
      d12 = d12f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      d27 = d27f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      f1 = m22 - m12 - p12
      f2 = m32 - m22 - p122 + p12
      f3 = m42 - m32 - p42  + p122
      r1 = c11_134 - c11_234  + f1 * d12
      r2 = c12_124 - c11_134  + f2 * d12 - 2.d0 * d27   
      r3 = c12_123 - c12_124  + f3 * d12 
      dp1p2 = p122 - p12 - p22 
      dp2p3 = p232 - p22 - p32 
      dp3p1 = p42 - p12 - p22 - p32 - dp1p2 - dp2p3
      x11 = 2.d0 * p12  
      x12 = dp1p2  
      x13 = dp3p1  
      x21 = dp1p2  
      x22 = 2.d0 * p22  
      x23 = dp2p3  
      x31 = dp3p1  
      x32 = dp2p3  
      x33 = 2.d0 * p32  
      det33 = -x13 * x22 * x31 + x12 * x23 * x31 + x13 * x21 * x32 
     &       - x11 * x23 * x32 - x12 * x21 * x33 + x11 * x22 * x33  
      i11 = - x23 * x32 + x22 * x33
      i12 = + x13 * x32 - x12 * x33
      i13 = - x13 * x22 + x12 * x23
      i21 = + x23 * x31 - x21 * x33
      i22 = - x13 * x31 + x11 * x33
      i23 = + x13 * x21 - x11 * x23
      i31 = - x22 * x31 + x21 * x32
      i32 = + x12 * x31 - x11 * x32
      i33 = - x12 * x21 + x11 * x22
      d22f = 1.d0/det33 * (i21 *r1 + i22 *r2 + i23 *r3) 
      return
      end

      complex*16 function d26f(mu,
     .         p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      implicit none 
      real*8    mu,p12,p22,p32,p42,p122,p232,m12,m22,m32,m42
      real*8    f1, f2, f3
      complex*16 r1, r2, r3
      real*8    x11,x12,x13,x21,x22,x23,x31,x32,x33
      real*8    i11,i12,i13,i21,i22,i23,i31,i32,i33
      real*8    det33,      dp1p2,dp2p3,dp3p1
      complex*16   c11f, c12f, d12f, d27f
      complex*16   c12_123, c12_124, c11_134, c11_234, d12, d27
      c11_234 = c11f(mu,p22,  p32,  p232, m22, m32, m42)
      c12_123 = c12f(mu,p12,  p22,  p122,  m12, m22, m32) 
      c12_124 = c12f(mu,p12,  p232, p42,  m12, m22, m42)
      c11_134 = c11f(mu,p122, p32,  p42,  m12, m32, m42)
      d12 = d12f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      d27 = d27f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      f1 = m22 - m12 - p12
      f2 = m32 - m22 - p122 + p12
      f3 = m42 - m32 - p42  + p122

      r1 = c11_134 - c11_234  + f1 * d12
      r2 = c12_124 - c11_134  + f2 * d12 - 2.d0 * d27   
      r3 = c12_123 - c12_124  + f3 * d12 

      dp1p2 = p122 - p12 - p22 
      dp2p3 = p232 - p22 - p32 
      dp3p1 = p42 - p12 - p22 - p32 - dp1p2 - dp2p3

      x11 = 2.d0 * p12  
      x12 = dp1p2  
      x13 = dp3p1  
      x21 = dp1p2  
      x22 = 2.d0 * p22  
      x23 = dp2p3  
      x31 = dp3p1  
      x32 = dp2p3  
      x33 = 2.d0 * p32  

      det33 = -x13 * x22 * x31 + x12 * x23 * x31 + x13 * x21 * x32 
     &       - x11 * x23 * x32 - x12 * x21 * x33 + x11 * x22 * x33  

      i11 = - x23 * x32 + x22 * x33
      i12 = + x13 * x32 - x12 * x33
      i13 = - x13 * x22 + x12 * x23
      i21 = + x23 * x31 - x21 * x33
      i22 = - x13 * x31 + x11 * x33
      i23 = + x13 * x21 - x11 * x23
      i31 = - x22 * x31 + x21 * x32
      i32 = + x12 * x31 - x11 * x32
      i33 = - x12 * x21 + x11 * x22

      d26f = 1.d0/det33 * (i31 *r1 + i32 *r2 + i33 *r3) 

      return
      end


      complex*16 function d23f(mu,
     .         p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      implicit none 
      real*8    mu,p12,p22,p32,p42,p122,p232,m12,m22,m32,m42
      real*8    f1, f2, f3
      complex*16 s1, s2, s3
      real*8    x11,x12,x13,x21,x22,x23,x31,x32,x33
      real*8    i11,i12,i13,i21,i22,i23,i31,i32,i33
      real*8    det33,      dp1p2,dp2p3,dp3p1
      complex*16   c12f, d13f, d27f
      complex*16   c12_123, c12_124, c12_134, c12_234, d13, d27
      c12_234 = c12f(mu,p22,  p32,  p232, m22, m32, m42)
      c12_123 = c12f(mu,p12,  p22,  p122,  m12, m22, m32) 
      c12_124 = c12f(mu,p12,  p232, p42,  m12, m22, m42)
      c12_134 = c12f(mu,p122, p32,  p42,  m12, m32, m42)
      d13 = d13f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      d27 = d27f(p12,p22,p32,p42,p122,p232,m12,m22,m32,m42)
      f1 = m22 - m12 - p12
      f2 = m32 - m22 - p122 + p12
      f3 = m42 - m32 - p42  + p122
      s1 = c12_134 - c12_234  + f1 * d13
      s2 = c12_124 - c12_134  + f2 * d13 
      s3 =         - c12_124  + f3 * d13 - 2.d0 * d27   
      dp1p2 = p122 - p12 - p22 
      dp2p3 = p232 - p22 - p32 
      dp3p1 = p42 - p12 - p22 - p32 - dp1p2 - dp2p3
      x11 = 2.d0 * p12  
      x12 = dp1p2  
      x13 = dp3p1  
      x21 = dp1p2  
      x22 = 2.d0 * p22  
      x23 = dp2p3  
      x31 = dp3p1  
      x32 = dp2p3  
      x33 = 2.d0 * p32  
      det33 = -x13 * x22 * x31 + x12 * x23 * x31 + x13 * x21 * x32 
     &       - x11 * x23 * x32 - x12 * x21 * x33 + x11 * x22 * x33  
      i11 = - x23 * x32 + x22 * x33
      i12 = + x13 * x32 - x12 * x33
      i13 = - x13 * x22 + x12 * x23
      i21 = + x23 * x31 - x21 * x33
      i22 = - x13 * x31 + x11 * x33
      i23 = + x13 * x21 - x11 * x23
      i31 = - x22 * x31 + x21 * x32
      i32 = + x12 * x31 - x11 * x32
      i33 = - x12 * x21 + x11 * x22
      d23f = 1.d0/det33 * (i31 *s1 + i32 *s2 + i33 *s3) 
      return
      end

  
CCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCCC
cccc d123f is the function defined in Eq.A4 in Jikia NPB41257(1994)
      complex*16 function d_st(p12,p22,p32,p122,p232,m2,mh)
      implicit none 
      complex*16    c0f
      complex*16    c0v
      real*8    a1,a2,a3,ns,nt,mh
      real*8    p12,p22,p32,p122,p132,p232,m2,m12,m22,q12,q22,q32
      ns=p122 
      nt=p232
      a2=1.d0-nt/2.d0/m2+dsqrt(-nt*(4.d0*m2-nt))/2.d0/m2
      a1=m2*(a2*2-1.d0)/(2.d0*m2*(a2-1.d0)+mh**2)
      a3=m2*(a2*2-1.d0)/(2.d0*m2*(a2-1.d0)+mh**2)
      q12=ns*a1**2
      q22=mh**2*a1+m2*(a1-1.d0)**2
      q32=q22
      m12=m2*a1**2
      m22=m2*a2**2
      d_st=a1*a2*a3/m2/(a2**2-1.d0)*
     .(c0f(q12,q22,q32,m12,m12,m22)
     .-c0f(q12,q22,q32,m12,m12,m2) ) 
      return
      end

      complex*16 function d_su(p12,p22,p32,p122,p232,m2,mh)
      implicit none 
      complex*16    c0f
      complex*16    c0v
      real*8    a1,a2,a3,ns,nt,mh
      real*8    p12,p22,p32,p122,p132,p232,m2,m12,m22,q12,q22,q32
      ns=p122 
      nt=p232
      a2=1.d0-nt/2.d0/m2+dsqrt(-nt*(4.d0*m2-nt))/2.d0/m2
      a1=m2*(a2*2-1.d0)/(2.d0*m2*(a2-1.d0)+mh**2)
      a3=m2*(a2*2-1.d0)/(2.d0*m2*(a2-1.d0)+mh**2)
      q12=ns*a1**2
      q22=mh**2*a1+m2*(a1-1.d0)**2
      q32=q22
      m12=m2*a1**2
      m22=m2*a2**2
      d_su=a1*a2*a3/m2/(a2**2-1.d0)*
     .(c0f(q22,q12,q32,m12,m12,m22)
     .     -c0f(q22,q12,q32,m12,m12,m2) ) 
      return
      end

      complex*16 function d_tu(p12,p22,p32,p122,p232,m2,mh)
      implicit none 
      complex*16    c0f
      complex*16    c0v
      real*8    a1,a2,a3,ns,nt,mh
      real*8    p12,p22,p32,p122,p132,p232,m2,m12,m22,q12,q22,q32
      ns=p122 
      nt=p232
      a2=1.d0-nt/2.d0/m2+dsqrt(-nt*(4.d0*m2-nt))/2.d0/m2
      a1=m2*(a2*2-1.d0)/(2.d0*m2*(a2-1.d0)+mh**2)
      a3=m2*(a2*2-1.d0)/(2.d0*m2*(a2-1.d0)+mh**2)
      q12=ns*a1**2
      q22=mh**2*a1+m2*(a1-1.d0)**2
      q32=q22
      m12=m2*a1**2
      m22=m2*a2**2
      d_tu=a1*a2*a3/m2/(a2**2-1.d0)*
     .(c0f(q12,q32,q22,m12,m12,m22)
     .     -c0f(q12,q32,q22,m12,m12,m2) ) 
      return
      end

      complex*16 function pole_w(s,mh,mw)
      implicit none
      complex*16 c0f
      real*8 s,mh,mw
      pole_w=
     .(s+2.d0*mh**2)/(2.d0*mw**2*(s-mh**2))*
     .(8.d0*mw**2*s*c0f(0.1d0,0.1d0,s,mw**2,mw**2,mw**2)
     .-(6.d0*mw**2+mh**2)*(1.d0+2.d0*mw**2*
     .c0f(0.1d0,0.01d0,s,mw**2,mw**2,mw**2)) ) 
      return 
      end

      complex*16 function boxpp_w(s,t,u,mh,mw)
      implicit none
      complex*16 c0f,d0f,d_st,d_su,d_tu
      real*8 s,t,u,mh,mw,mw2
      real*8 p12,p22,p32,p42,p122,p132,p232
      real*8 m4
      p12=0.d0**2
      p22=0.d0**2
      p32=mh**2
      p42=mh**2
      p122=s
      p132=u
      p232=t
      m4=mh**4-4.d0*mh**2*mw**2+12.d0*mw**4
       boxpp_w=
     .4.d0*mw**2*s*(
     .+d0f(p12,p32,p22,p42,p132,p232,mw**2,mw**2,mw**2,mw**2)  !tu
     .+d0f(p12,p22,p32,p42,p122,p232,mw**2,mw**2,mw**2,mw**2)  !st
     .+d0f(p22,p12,p32,p42,p122,p132,mw**2,mw**2,mw**2,mw**2)  !su  
     . )                       
     .-4.d0*s*c0f(p12,p22,p122,mw**2,mw**2,mw**2)  
     .+m4*(
     .(
     .+2.d0*(t-mh**2)*c0f(p22,p32,p232,mw**2,mw**2,mw**2)
     .+2.d0*(u-mh**2)*c0f(p12,p32,p132,mw**2,mw**2,mw**2)
     .-(t*u-mh**4)*
     .d0f(p12,p32,p22,p42,p132,p232,mw**2,mw**2,mw**2,mw**2) !tu 
     . )/2.d0/mw**2/s
     .-d0f(p12,p32,p22,p42,p132,p232,mw**2,mw**2,mw**2,mw**2)  !tu
     .-d0f(p12,p22,p32,p42,p122,p232,mw**2,mw**2,mw**2,mw**2)  !st
     .-d0f(p22,p12,p32,p42,p122,p132,mw**2,mw**2,mw**2,mw**2)  !su  
     .)
      return 
      end

      complex*16 function boxpm_w(s,t,u,mh,mw)
      implicit none
      complex*16 c0f,d0f,d_st,d_su,d_tu
      real*8 s,t,u,mh,mw,mw2
      real*8 p12,p22,p32,p42,p122,p132,p232,p342
      real*8 m4
      p12=0.d0**2
      p22=0.d0**2
      p32=mh**2
      p42=mh**2
      p122=s
      p132=u
      p232=t
      p342=p122
      m4=mh**4-4.d0*mh**2*mw**2+12.d0*mw**4
      boxpm_w=
     .2.d0*(t*u-mh**4)*
     .d0f(p12,p32,p22,p42,p132,p232,mw**2,mw**2,mw**2,mw**2) !tu 
     .-4.d0*s*c0f(p12,p22,p122,mw**2,mw**2,mw**2) 
     .+1.d0/(2.d0*mw**2*(t*u-mh**4))*(
     .(t-mh**2)*(4.d0*mw**2*(t-mh**2)**2-m4*t)*
     .(2.d0*c0f(p22,p32,p232,mw**2,mw**2,mw**2)
     .+(t-mh**2)*
     .d0f(p12,p22,p32,p42,p122,p232,mw**2,mw**2,mw**2,mw**2)) !st
     .+(u-mh**2)*(4.d0*mw**2*(u-mh**2)**2-m4*u)*
     .(2.d0*c0f(p12,p32,p132,mw**2,mw**2,mw**2)
     .+(u-mh**2)*
     .+d0f(p22,p12,p32,p42,p122,p132,mw**2,mw**2,mw**2,mw**2)  !su  
     .))
     .+(m4+4.d0*mw**2*s)/2.d0/mw**2*(
     .s/(t*u-mh**4)*(
     .(s-2.d0*mh**2)*c0f(p12,p22,p122,mw**2,mw**2,mw**2)
     .+(s-4.d0*mh**2)*c0f(p32,p42,p342,mw**2,mw**2,mw**2))
     .-(t-2.d0*mw**2)*
     .d0f(p12,p22,p32,p42,p122,p232,mw**2,mw**2,mw**2,mw**2) !st
     .-(u-2.d0*mw**2)*
     .d0f(p22,p12,p32,p42,p122,p132,mw**2,mw**2,mw**2,mw**2) !su
     .+2.d0*mw**2*
     .d0f(p12,p32,p22,p42,p132,p232,mw**2,mw**2,mw**2,mw**2) !tu 
     .-2.d0*c0f(p32,p42,p342,mw**2,mw**2,mw**2)
     . )
      return 
      end

      complex*16 function delpole_w(s,mh,mw,delkappa)
      implicit none
      complex*16 c0f,d0f
      real*8 s,mh,mw,delkappa
      real*8 p12,p22,p122
      p12=0d0**2
      p22=0d0**2
      p122=s
      delpole_w=
     .-3.d0*delkappa*mh**2/(s-mh**2)*
     .(3.d0+s/2.d0/mw**2-3.d0*(s-2.d0*mw**2)*
     .c0f(p12,p22,p122,mw**2,mw**2,mw**2) 
     .) 
      return 
      end

      complex*16 function pole_t(s,mh,mw,mt,delkappa)
      implicit none
      complex*16 c0f
      real*8 s,mh,mw,mt,delkappa
      real*8 p12,p22,p122
      p12=0d0**2
      p22=0d0**2
      p122=s
      pole_t=
     .4.d0*mh**2*mt**2*(1.d0+delkappa)/mw**2/(s-mh**2)*
     .(2.d0-(s-4.d0*mt**2)*
     .c0f(p12,p22,p122,mt**2,mt**2,mt**2) 
     . ) 
      return 
      end

      complex*16 function boxpp_t(s,t,u,mh,mw,mt)
      implicit none
      complex*16 c0f,d0f
      real*8 s,t,u,mh,mw,mt
      real*8 p12,p22,p32,p42,p122,p132,p232
      p12=0.d0**2
      p22=0.d0**2
      p32=mh**2
      p42=mh**2
      p122=s
      p132=u
      p232=t
c     Glover Bij formula       
      boxpp_t=+4.d0*mt**2/3.d0/mw**2*(     
     .mt**2*(8.d0*mt**2-s-2.d0*mh**2)*
     . (    
     . +d0f(p12,p22,p32,p42,p122,p232,mt**2,mt**2,mt**2,mt**2) !st
     .+d0f(p12,p32,p22,p42,p132,p232,mt**2,mt**2,mt**2,mt**2) !tu
     .+d0f(p22,p12,p32,p42,p122,p132,mt**2,mt**2,mt**2,mt**2) !su  
     .)
     .+(t*u-mh**4)/s*(4.d0*mt**2-mh**2) *
     .d0f(p12,p32,p22,p42,p132,p232,mt**2,mt**2,mt**2,mt**2) !tu
     .+2.d0+4.d0*mt**2*c0f(p12,p22,p122,mt**2,mt**2,mt**2) 
     .+2.d0/s*(mh**2-4.d0*mt**2)*(
     .+(u-mh**2)*c0f(p12,p32,p132,mt**2,mt**2,mt**2)  
     .+(t-mh**2)*c0f(p22,p32,p232,mt**2,mt**2,mt**2)   ) )
      return 
      end
csk
      complex*16 function boxpm_t(s,t,u,mh,mw,mt)
      implicit none
      complex*16 c0f,d0f
      real*8 s,t,u,mh,mw,mt
      real*8 p12,p22,p32,p42,p122,p132,p232,p342
      p12=0.d0**2
      p22=0.d0**2
      p32=mh**2
      p42=mh**2
      p122=s
      p132=u
      p232=t
      p342=p122
      boxpm_t=-2.d0*mt**2/3.d0/mw**2*(
     .2.d0*(8.d0*mt**2+s-2.d0*mh**2)*
     .(
     .mt**2*(
     .+d0f(p12,p22,p32,p42,p122,p232,mt**2,mt**2,mt**2,mt**2) !st
     .+d0f(p12,p32,p22,p42,p132,p232,mt**2,mt**2,mt**2,mt**2) !tu
     .+d0f(p22,p12,p32,p42,p122,p132,mt**2,mt**2,mt**2,mt**2) !su  
     .)-c0f(p32,p42,p342,mt**2,mt**2,mt**2) 
     .)
     . -2.d0*(
     . s*c0f(p12,p22,p122,mt**2,mt**2,mt**2)
     .+(u-mh**2)*c0f(p12,p32,p132,mt**2,mt**2,mt**2)
     .+(t-mh**2)*c0f(p22,p32,p232,mt**2,mt**2,mt**2)
     .)
     .+1.d0/(u*t-mh**4)*(
     .+s*t*(8.d0*t*mt**2-t**2-mh**4)*
     .d0f(p12,p22,p32,p42,p122,p232,mt**2,mt**2,mt**2,mt**2) !st
     .+s*u*(8.d0*u*mt**2-u**2-mh**4)*
     .+d0f(p22,p12,p32,p42,p122,p132,mt**2,mt**2,mt**2,mt**2) !su  
     .+(8.d0*mt**2+s-2.d0*mh**2)*
     .(
     .+s*(s-2.d0*mh**2)*c0f(p12,p22,p122,mt**2,mt**2,mt**2)
     .+s*(s-4.d0*mh**2)*c0f(p32,p42,p342,mt**2,mt**2,mt**2)
     .+2.d0*u*(mh**2-u)*c0f(p12,p32,p132,mt**2,mt**2,mt**2) 
     .+2.d0*t*(mh**2-t)*c0f(p22,p32,p232,mt**2,mt**2,mt**2) 
     . )) 
     .) 
      return 
      end

      complex*16 function amp_pp(s,t,u,mh,mt,mw,delkappa)
      implicit none
      complex*16 pole_w,delpole_w,boxpp_w,boxpm_w
      complex*16 pole_t,boxpp_t,boxpm_t
      real*8 s,t,u,mh,mt,mw,delkappa
      amp_pp=
     .+pole_w(s,mh,mw)+delpole_w(s,mh,mw,delkappa)
     .+boxpp_w(s,t,u,mh,mw) 
     .+pole_t(s,mh,mw,mt,delkappa)
     .+boxpp_t(s,t,u,mh,mw,mt) 
      return
      end

      complex*16 function amp_pm(s,t,u,mh,mt,mw,delkappa)
      implicit none
      complex*16 pole_w,delpole_w,boxpp_w,boxpm_w
      complex*16 pole_t,boxpp_t,boxpm_t
      real*8 s,t,u,mh,mt,mw,delkappa
      amp_pm=
     .+boxpm_w(s,t,u,mh,mw)
     .+boxpm_t(s,t,u,mh,mw,mt) 
      return
      end

cccc  dsigma/dt cccc      

      real*8 function dsdt_pp(s,t,mh,mt,mw,delkappa)
      implicit none
      real*8 s,t,u,mh,mt,mw,delkappa
      real*8 al_em,al_w,vpi
      complex*16 amp_pp
      vpi=3.14159265358979323846d0
      al_em=1.d0/128.d0
      al_w=1.d0/30.d0
      u=-s-t+2.d0*mh**2
      dsdt_pp=al_em**2*al_w**2/(16.d0*vpi*s**2)*
     .dble(amp_pp(s,t,u,mh,mt,mw,delkappa)*
     .conjg(amp_pp(s,t,u,mh,mt,mw,delkappa)))*3.8937966d+11   
     .*(1.d0/2.d0) ! <--- this is from statistics of HH 
      return
      end

      real*8 function dsdt_pm(s,t,mh,mt,mw,delkappa)
      implicit none
      real*8 s,t,u,mh,mt,mw,delkappa
      real*8 al_em,al_w,vpi
      complex*16 amp_pm
      vpi=3.14159265358979323846d0
      al_em=1.d0/128.d0
      al_w=1.d0/30.d0
      u=-s-t+2.d0*mh**2
      dsdt_pm=al_em**2*al_w**2/(16.d0*vpi*s**2)*
     .dble(amp_pm(s,t,u,mh,mt,mw,delkappa)*
     .conjg(amp_pm(s,t,u,mh,mt,mw,delkappa)))*3.8937966d+11     
     .*(1.d0/2.d0) ! <--- this is from statistics of HH 
      return
      end

cccc  dsigma/d(cos(theta)) cccc      
c    cos(theta)=ct
ccccccccccccccccccccccccccccccc
      real*8 function dsdc_pp(s,ct,mh,mt,mw,delkappa)
      implicit none
      real*8 s,ct,mh,mt,mw,delkappa
      real*8 t,u
      real*8 dsdt_pp,bg
      t=(-s+2.d0*mh**2)/2.d0+s*bg(s,mh**2,mh**2)/2.d0*ct
      u=-s-t+2.d0*mh**2
      dsdc_pp=s/2.d0*dsqrt(1.d0-4.d0*mh**2/s)*
     .dsdt_pp(s,t,mh,mt,mw,delkappa)
      return
      end

      real*8 function dsdc_pm(s,ct,mh,mt,mw,delkappa)
      implicit none
      real*8 s,ct,mh,mt,mw,delkappa
      real*8 t,u
      real*8 dsdt_pm,bg
      t=(-s+2.d0*mh**2)/2.d0+s*bg(s,mh**2,mh**2)/2.d0*ct
      u=-s-t+2.d0*mh**2
      dsdc_pm=s/2.d0*dsqrt(1.d0-4.d0*mh**2/s)*
     . dsdt_pm(s,t,mh,mt,mw,delkappa)
      return
      end

      real*8 function tmax(s,mg2,mw2)
      implicit none
      real*8 s, mg2, mw2
      real*8 bg

      tmax = (-s + mg2 + mw2)/2.d0 + s * bg(s,mg2,mw2)/2.d0 

      return 
      end


      real*8 function tmin(s,mg2,mw2)
      implicit none
      real*8 s, mg2, mw2
      real*8 bg

      tmin = (-s + mg2 + mw2)/2.d0 - s * bg(s,mg2,mw2)/2.d0 

      return 
      end

      real*8 function subsig_pp(s,mh,mt,mw,delkappa)
      implicit none
      real*8 dsdc_pp,s,mh,mt,mw,delkappa,epsilon
      integer no,j
      real*8 a,b,h,sum,x0,y1,y2,y3,y4,y5
      dimension    x0(1000)
      external dsdc_pp
      epsilon=10.d0**(-6)
         a =  -1.d0+epsilon
         b =  +1.d0-epsilon
         y1  = s
         y2  = mh
         y3  = mt
         y4  = mw
         y5  = delkappa
         no = 100  !(-- take this (Error < 0.2 %))
         h = dabs(a - b)/no 
         do 10  j = 1, no
            x0(j) = a + j * h 
 10      continue 
         call simpson5(sum,x0,y1,y2,y3,y4,y5,no,h,dsdc_pp)
         subsig_pp=sum
         return
         end     


      real*8 function subsig_pm(s,mh,mt,mw,delkappa)
      implicit none
      real*8 dsdc_pp,s,mh,mt,mw,delkappa,epsilon
      integer no,j
      real*8 a,b,h,sum,x0,y1,y2,y3,y4,y5
      dimension    x0(1000)
      external dsdc_pm
      epsilon=10.d0**(-6)
         a =  -1.d0+epsilon
         b =  +1.d0-epsilon
         y1  = s
         y2  = mh
         y3  = mt
         y4  = mw
         y5  = delkappa
         no = 100  !(-- take this (Error < 0.2 %))
         h = dabs(a - b)/no 
         do 10  j = 1, no
            x0(j) = a + j * h 
 10      continue 
         call simpson5(sum,x0,y1,y2,y3,y4,y5,no,h,dsdc_pm)
         subsig_pm=sum
         return
         end


ccccccccc full process ccccccccccc 
      real*8 function f(x,y,lam,pc)
      implicit none
      real*8 x,y,lam,pc
      real*8 r
      r=y/(x*(1.d0-y))
      f=(1.d0/(1.d0-y)+1.d0-y-4.d0*r*(1.d0-r)
     .-2.d0*lam*pc*r*x*(2.d0*r-1.d0)*(2.d0-y))/
     .((1.d0-4.d0/x-8.d0/x**2)*dlog(x+1.d0)
     .+1.d0/2.d0+8.d0/x-1.d0/2.d0/(x+1.d0)**2+
     .2.d0*lam*pc*((1.d0+2.d0/x)*dlog(x+1.d0)
     . -5.d0/2.d0+1.d0/(x+1.d0)-1.d0/2.d0/(x+1.d0)**2) )
      return 
      end


ccccc  xi
      real*8 function xi(x,y,lam,pc)
      implicit none 
      real*8 x,y,r,lam,pc
      real*8 c00,c20
      r=y/(x*(1.d0-y))
      c00=1.d0/(1.d0-y)+1.d0-y-4.d0*r*(1.d0-r)
     .-2.d0*lam*pc*r*x*(2.d0*r-1.d0)*(2.d0-y)
      c20=2.d0*lam*r*x*(1.d0+(1.d0-y)*(2.d0*r-1.d0)**2)
     .-pc*(2.d0*r-1.d0)*(1.d0/(1.d0-y)+1.d0-y)

      xi=c20/c00

      return
      end

      real*8 function xi12(x,y,tau,lam1,lam2,pc1,pc2)
      implicit none 
      real*8 x,y,lam1,lam2,pc1,pc2
      real*8 xi,tau
      xi12=xi(x,y,lam1,pc1)*xi(x,tau/y,lam2,pc2)
      return
      end
cccccc

      real*8 function int_ff(x,y,tau,lam1,lam2,pc1,pc2)
      implicit none
      real*8 f
      real*8 x,y,lam1,lam2,tau,pc1,pc2
      int_ff=f(x,y,lam1,pc1)*f(x,tau/y,lam2,pc2)/y
      return 
      end
      
      real*8 function dLdtau(x,tau,lam1,lam2,pc1,pc2)
      integer i
      real*8 x,y,lam,lam1,lam2,pc1,pc2
      real*8 f,vf
      integer no,j
      real*8 a,b,h,sum,x0,y1,y2,y3,y4,y5,y6
      real*8 tau,taumin,taumax,mh,s,int_ff,ym
      dimension    x0(1000)
      external int_ff
      ym=x/(x+1.d0)
         a =  tau/ym
         b =  ym
         y1 = x
         y2 = tau
         y3 = lam1
         y4 = lam2
         y5 = pc1
         y6 = pc2
         no = 200  !(-- take this (Error < 0.2 %))
         h = dabs(a - b)/no 
         do 10  j = 1, no
            x0(j) = a + j * h 
 10      continue 
         call simpson6(sum,x0,y1,y2,y3,y4,y5,y6,no,h,int_ff)
         dLdtau=sum
      return
      end

      real*8 function av_xi12(x,tau,lam1,lam2,pc1,pc2)
      integer i
      real*8 x,y,lam,lam1,lam2,pc1,pc2
      real*8 f,vf
      integer no,j
      real*8 a,b,h,sum,x0,y1,y2,y3,y4,y5,y6
      real*8 tau,taumin,taumax,mh,s,xi12,ym
      dimension    x0(1000)
      external xi12
      ym=x/(x+1.d0)
         a =  tau/ym
         b =  ym
         y1 = x
         y2 = tau
         y3 = lam1
         y4 = lam2
         y5 = pc1
         y6 = pc2
         no = 100  !(-- take this (Error < 0.2 %))
         h = dabs(a - b)/no 
         do 10  j = 1, no
            x0(j) = a + j * h 
 10      continue 
         call simpson6(sum,x0,y1,y2,y3,y4,y5,y6,no,h,xi12)
         av_xi12=sum/(b-a)
      return
      end

#if 1
      real*8 function Lgg(x,taumin,taumax,lam1,lam2,pc1,pc2)
      integer i
      real*8 x,taumin,taumax,lam1,lam2,pc1,pc2

      integer no,j
      real*8 a,b,h,sum,x0,y1,y2,y3,y4,y5
      real*8 dLdtau

      dimension    x0(100000)
      external dLdtau
      ym=x/(x+1.d0)
         a =  taumin
         b =  taumax
         y1  = x
         y2  = lam1
         y3  = lam2
         y4  = pc1
         y5  = pc2
         no = 10000 !(-- take this (Error < 0.2 %))
         h = dabs(a - b)/no 
         do 10  j = 1, no
            x0(j) = a + j * h 
 10      continue 
         call simpson5(sum,x0,y1,y2,y3,y4,y5,no,h,dLdtau)
         Lgg=sum
      return
      end
#endif

cccccccccccccccc
csk
      real*8 function dLdtaudsdc(
     . x,tau,ct,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
      integer i
      real*8 x,tau,lam1,lam2,pc1,pc2
      real*8 av_xi12,dsdcpp,dsdcmm,s,ct,mh,mt,mw,delkappa
      real*8 dLdtau, dsdc_pp,dsdc_pm,ym
      ym=x/(1.d0+x)
      dLdtaudsdc=dLdtau(x,tau,lam1,lam2,pc1,pc2)*
     .(
     . +(1.d0+av_xi12(x,tau,lam1,lam2,pc1,pc2))/2.d0*
     . dsdc_pp(tau*s,ct,mh,mt,mw,delkappa)
     . +(1.d0-av_xi12(x,tau,lam1,lam2,pc1,pc2))/2.d0*
     . dsdc_pm(tau*s,ct,mh,mt,mw,delkappa)
     . )
      return
      end


cccccccccccc
c      vdLdtaudsdc=dLdtaudsdc(
c     . x,tau,lam1,lam2,xi12,subs,ct,mh,mt,mw,delkappa)

csk
      real*8 function full_dsdc(
     . x,ct,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
      implicit none
      real*8 a,b,h,sum,x0,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,y12      
      integer j, n, i, k, no
      real*8 x,tau,lam1,lam2,xi12,subs,ct,mh,mt,mw,delkappa
      real*8 s,ym,taumin,taumax,pc1,pc2,taumin1,taumin2
      real*8 dLdtaudsdc
      dimension    x0(1000)
      external dLdtaudsdc
      ym=x/(1.d0+x)
      taumin1=4.d0*mh**2/s
      taumin2=(0.8d0*ym)**2         
      taumin=max(taumin1,taumin2)   
      taumax=ym**2
         a =  taumin
         b =  taumax
         y1 = x
         y2 = ct
         y3 = lam1
         y4 = lam2
         y5= s
         y6 = mh
         y7 =mt
         y8 = mw
         y9= delkappa
         y10= pc1
         y11= pc2
         no = 100  !(-- take this (Error < 0.2 %))
         h = dabs(a - b)/no 
         do 10  j = 1, no
            x0(j) = a + j * h 
 10      continue 
         call simpson11(sum,
     .    x0,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,no,h,dLdtaudsdc)
         full_dsdc=sum
         return
         end

      real*8 function full_sigma(
     . x,lam1,lam2,s,mh,mt,mw,delkappa,pc1,pc2)
      implicit none
      real*8 a,b,h,sum,x0,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11      
      integer j, n, i, k, no
      real*8 x,tau,lam1,lam2,xi12,s,ct,mh,mt,mw,delkappa,pc1,pc2
      real*8 full_dsdc
      dimension    x0(1000)
      external full_dsdc
         a =  -1.d0
         b =  +1.d0
         y1 = x
         y2 = lam1
         y3 = lam2
         y4 = s
         y5 = mh
         y6= mt
         y7= mw
         y8= delkappa
         y9= pc1
         y10= pc2
         no = 100  !(-- take this (Error < 0.2 %))
         h = dabs(a - b)/no 
         do 10  j = 1, no
            x0(j) = a + j * h 
 10      continue 
         call simpson10(sum,
     . x0,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,no,h,full_dsdc)
         full_sigma=sum

         return
         end


cccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccccc
      subroutine simpson2(sum,x,y1,y2,n,h,f)
      implicit none
      double precision  sum,x(*),h,f,y1,y2
      integer I,n
      sum = 0.0
      do 10 I = 1, (n-2), 2
         sum = sum 
     &        +       f(y1,x(I),y2) 
     &        + 4.0 * f(y1,x(I+1),y2) 
     &        +       f(y1,x(I+2),y2)
 10   continue 
      sum = sum * h/3.0
      return 
      end

      subroutine simpson3(sum,x,y1,y2,y3,n,h,f)
      implicit none
      double precision  sum,x(*),h,f,y1,y2,y3
      integer I,n
      sum = 0.0
      do 10 I = 1, (n-2), 2
         sum = sum 
     &        +       f(y1,x(I),y2,y3) 
     &        + 4.0 * f(y1,x(I+1),y2,y3) 
     &        +       f(y1,x(I+2),y2,y3)
 10   continue 
      sum = sum * h/3.0
      return 
      end

      subroutine simpson4(sum,x,y1,y2,y3,y4,n,h,f)
      implicit none
      double precision  sum,x(*),h,f,y1,y2,y3,y4
      integer I,n
      sum = 0.0
      do 10 I = 1, (n-2), 2
         sum = sum 
     &        +       f(y1,x(I),y2,y3,y4) 
     &        + 4.0 * f(y1,x(I+1),y2,y3,y4) 
     &        +       f(y1,x(I+2),y2,y3,y4)
 10   continue 
      sum = sum * h/3.0
      return 
      end

      subroutine simpson5(sum,x,y1,y2,y3,y4,y5,n,h,f)
      implicit none
      double precision  sum,x(*),h,f,y1,y2,y3,y4,y5
      integer I,n
      sum = 0.0
      do 10 I = 1, (n-2), 2
         sum = sum 
     &        +       f(y1,x(I),y2,y3,y4,y5) 
     &        + 4.0 * f(y1,x(I+1),y2,y3,y4,y5) 
     &        +       f(y1,x(I+2),y2,y3,y4,y5)
 10   continue 
      sum = sum * h/3.0
      return 
      end

      subroutine simpson6(sum,x,y1,y2,y3,y4,y5,y6,n,h,f)
      implicit none
      double precision  sum,x(*),h,f,y1,y2,y3,y4,y5,y6
      integer I,n
      sum = 0.0
      do 10 I = 1, (n-2), 2
         sum = sum 
     &        +       f(y1,x(I),y2,y3,y4,y5,y6) 
     &        + 4.0 * f(y1,x(I+1),y2,y3,y4,y5,y6) 
     &        +       f(y1,x(I+2),y2,y3,y4,y5,y6)
 10   continue 
      sum = sum * h/3.0
      return 
      end

      subroutine simpson9(sum,x,y1,y2,y3,y4,y5,y6,y7,y8,y9,n,h,f)
      implicit none
      double precision  sum,x(*),h,f,y1,y2,y3,y4,y5,y6,y7,y8,y9
      integer I,n
      sum = 0.0
      do 10 I = 1, (n-2), 2
         sum = sum 
     &        +       f(y1,x(I),y2,y3,y4,y5,y6,y7,y8,y9) 
     &        + 4.0 * f(y1,x(I+1),y2,y3,y4,y5,y6,y7,y8,y9) 
     &        +       f(y1,x(I+2),y2,y3,y4,y5,y6,y7,y8,y9)
 10   continue 
      sum = sum * h/3.0
      return 
      end

      subroutine simpson10(sum,x,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,n,h,f)
      implicit none
      double precision  sum,x(*),h,f,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10
      integer I,n
      sum = 0.0
      do 10 I = 1, (n-2), 2
         sum = sum 
     &        +       f(y1,x(I),y2,y3,y4,y5,y6,y7,y8,y9,y10) 
     &        + 4.0 * f(y1,x(I+1),y2,y3,y4,y5,y6,y7,y8,y9,y10) 
     &        +       f(y1,x(I+2),y2,y3,y4,y5,y6,y7,y8,y9,y10)
 10   continue 
      sum = sum * h/3.0
      return 
      end

      subroutine simpson11(sum,x,
     . y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,n,h,f)
      implicit none
      double precision  sum,x(*),h,f,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11
      integer I,n
      sum = 0.0
      do 10 I = 1, (n-2), 2
         sum = sum 
     &        +       f(y1,x(I),y2,y3,y4,y5,y6,y7,y8,y9,y10,y11) 
     &        + 4.0 * f(y1,x(I+1),y2,y3,y4,y5,y6,y7,y8,y9,y10,y11) 
     &        +       f(y1,x(I+2),y2,y3,y4,y5,y6,y7,y8,y9,y10,y11)
 10   continue 
      sum = sum * h/3.0
      return 
      end      

      subroutine simpson12(sum,x,
     . y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,y12,n,h,f)
      implicit none
      double precision  
     . sum,x(*),h,f,y1,y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,y12
      integer I,n 
      sum = 0.0
      do 10 I = 1, (n-2), 2
         sum = sum 
     &        +       f(y1,x(I),y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,y12) 
     &        + 4.0 * f(y1,x(I+1),y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,y12) 
     &        +       f(y1,x(I+2),y2,y3,y4,y5,y6,y7,y8,y9,y10,y11,y12)
 10   continue 
      sum = sum * h/3.0
      return 
      end

