      complex*16 function ampww(gwwa,mw,gamw,gwf, ihel,kv, fhel,mf,pv)

      implicit real*8 (a-h, o-z)
      integer*4  np
      parameter (np = 4)
      integer*4  ihel(2), fhel(np)
      real   *8  gwwa, mw, gamw, gwf(2)
      real   *8  kv(0:3,2), pv(0:3,np), mf(np)

C--
#ifdef __NODECAY__
      real   *8  qv(0:3,2)
#endif
      complex*16 spinor(6,np), wvct(6,2), avct(6,2), amp
      real   *8  ma
      integer*4  nf(np,2)
      data nf  / -1, +1,   +1, -1,
     .           +1, -1,   -1, +1 /
      integer*4  ncall /0/
C
C========< Entry Point >================================================
C
C--
C  Initialize parameters.
C--
      if (ncall.eq.0) then
         ncall = 1
         ma = 0
      endif
C--
C  Prepare wave function for initial photons.
C--
      call vxxxxx(kv(0,1),ma,ihel(1),-1,avct(1,1))
      call vxxxxx(kv(0,2),ma,ihel(2),-1,avct(1,2))
#ifndef __NODECAY__
C--
C  Prepare spinors for external lines.
C--
      do ip = 1, np
         if (nf(ip,2).gt.0 ) then
            call ixxxxx(pv(0,ip),mf(ip),fhel(ip),nf(ip,1),spinor(1,ip))
         else
            call oxxxxx(pv(0,ip),mf(ip),fhel(ip),nf(ip,1),spinor(1,ip))
         endif
      enddo
C--
C  Prepare wave function for W- and W+.
C--
      call jioxxx(spinor(1,1),spinor(1,2),gwf,mw,gamw,wvct(1,1))
      call jioxxx(spinor(1,4),spinor(1,3),gwf,mw,gamw,wvct(1,2))
#else
      do iv = 1, 2
         do i = 0, 3
            qv(i,iv) = pv(i,2*iv-1) + pv(i,2*iv)
         enddo
         call vxxxxx(qv(0,iv),mw,fhel(iv),+1,wvct(1,iv))
      enddo
#endif
C--
C  Calculate amplitude**2.
C--
      call w3w3xx(wvct(1,1),avct(1,1),wvct(1,2),avct(1,2),
     .            gwwa,gwwa, mw, gamw, amp);
      ampww = amp
C--
C  That's it.
C--
      return
      end
