#include <iomanip>
void nsim(Int_t irun)
{ 
  gROOT->Reset();

  stringstream sfname;
  sfname << "data/aa_zzsim" << setw(2) << setfill('0') << irun << ".gldv4p.root" << ends;
  TFile file(sfname.str().data(),"RECREATE");  // Output file
  cerr << "-------------------------------" << endl;
  cerr << " Opened " << sfname.str().data() << endl;

  JSFSteer jsf;
  JSFLCFULL full;
  ZZSpring spring("ZZSpring");

  stringstream slname;
  slname << "data/aa_zzsim" << setw(2) << setfill('0') << irun-1 << ".gldv4p.root" << ends;
  cerr << " Read "   << slname.str().data() << endl;
  cerr << "-------------------------------" << endl;
  TFile flast(slname.str().data(),"READ");  // Last run file
  jsf.GetLastRunInfo(&flast);
  flast.Close();

  JSFHadronizer hdr;
  JSFQuickSim sim;

  spring.ReadBases("bases.root");

  Int_t maxevt=100;      // Number of events.
  jsf.Initialize();

  printf(" Roots is %g\n",((ZZBases*)spring.GetBases())->GetEcm());
  jsf.BeginRun(30+irun-1);      // Set run number to 30.

  Int_t ev = 1;
  while (1) {
    printf(" start event %d ",ev);
    if (jsf.Process(ev)) {
      printf("Processed event %d ",ev);

      jsf.FillTree();
      jsf.Clear();

      printf(" End event %d \n",ev);
      if (ev >= maxevt) break;
      ev++;
    }
  }
  jsf.Terminate();
  //file.Write();
}
